SystemOrganization addCategory: #'SightC-Analyzing'!
SystemOrganization addCategory: #'SightC-Browser'!
SystemOrganization addCategory: #'SightC-Coverage'!
SystemOrganization addCategory: #'SightC-Cst'!
SystemOrganization addCategory: #'SightC-Distribution'!
SystemOrganization addCategory: #'SightC-DistributionTests'!
SystemOrganization addCategory: #'SightC-Driving'!
SystemOrganization addCategory: #'SightC-Events'!
SystemOrganization addCategory: #'SightC-Install'!
SystemOrganization addCategory: #'SightC-TestTracer'!
SystemOrganization addCategory: #'SightC-Tests'!
SystemOrganization addCategory: #'SightC-Text'!

ListItemWrapper subclass: #STestCaseItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!STestCaseItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 12/16/2009 12:07'!
asString

	^ item name! !

!STestCaseItemWrapper methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:48.398'!
contents

	^ item value collect: [:test |
		STestItemWrapper with: test]! !

ListItemWrapper subclass: #STestItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!STestItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 12/16/2009 11:57'!
asString

	^ item selector asString! !

TestResult subclass: #STestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!STestResult methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:22:31.615'!
addToPassed: aTestCase
	passed add: aTestCase! !

!TestResult methodsFor: '*SightC' stamp: 'bs 1/15/2010 21:48'!
defectTestMethods
	^ (self defects collect: [ :aTestCase | aTestCase class >> aTestCase selector ]) asIdentitySet! !

!TestResult methodsFor: '*SightC' stamp: 'bs 12/22/2009 18:34'!
isDefect: aTestMethod
	|selector class|
	selector := aTestMethod selector.
	class := aTestMethod methodClass.
	
	^ self defects 
		anySatisfy: [ :testCase | 
			(testCase selector == selector) and: [testCase class == class] ]! !

!TestResult methodsFor: '*SightC' stamp: 'bs 2/20/2010 21:23:04.994'!
postCopy
	failures := failures collect: [ :ea | ea class selector: ea selector ].
	errors := errors collect: [ :ea | ea class selector: ea selector ].
	passed := passed collect: [ :ea | ea class selector: ea selector ].! !

!TestResult methodsFor: '*SightC' stamp: 'bs 12/22/2009 15:25'!
removeIfPresent: aTestMethod
	|selector class|
	selector := aTestMethod selector.
	class := aTestMethod methodClass.
	{errors. failures. passed} do: [ :aTestSet | 
		aTestSet 
			select: [ :testCase | (testCase selector == selector) and: [testCase class == class] ]
			thenDo: [ :testCase | aTestSet remove: testCase. ] ].! !

!TestResult methodsFor: '*SightC-override' stamp: 'bs 12/21/2009 12:36'!
runCase: aTestCase
	| testCasePassed |
	testCasePassed := true.
	[[aTestCase runCase] 
			on: self class failure
			do: 
				[:signal | 
				failures add: aTestCase.
				testCasePassed := false.
				aTestCase recordRunFailedWith: signal.
				signal return: false]]
					on: self class error
					do:
						[:signal |
						errors add: aTestCase.
						testCasePassed := false.
						aTestCase recordRunFailedWith: signal.
						signal return: false].
	testCasePassed 
		ifTrue: [
			passed add: aTestCase.
			aTestCase recordRunWasSuccessful]! !

SimpleHierarchicalListMorph subclass: #STestTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!STestTree class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 23:27'!
on: someTestCases

	^ self
			on: [Array with:  (MorphWithSubmorphsWrapper with: World)]
			list: #value
			selected: nil
			changeSelected: nil
			menu: nil
			keystroke: nil! !

!STestTree methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:05.267'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderWidth: 0;
		extent: (SActivityMorph defaultWidth - 10 ) @ 50;
		color: (Color white alpha: 0.7).! !

!STestTree methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 23:18'!
scrollBarThickness

	^ 5! !

SimpleHierarchicalListMorph subclass: #STreeMorph
	instanceVariableNames: 'scrollBarThickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!STreeMorph class methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 11:41'!
on: someTestCases

	^ self
			on: [Array with:  (MorphWithSubmorphsWrapper with: World)]
			list: #value
			selected: nil
			changeSelected: nil
			menu: nil
			keystroke: nil! !

!STreeMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:05.275'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderWidth: 0;
		extent: (SActivityMorph defaultWidth - 10 ) @ 50;
		color: (Color white alpha: 0.7);
		scrollBarThickness: 5.! !

!STreeMorph methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 11:43'!
scrollBarThickness
	^ scrollBarThickness ifNil: [super scrollBarThickness]! !

!STreeMorph methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 11:43'!
scrollBarThickness: aPositiveInteger
	scrollBarThickness := aPositiveInteger! !

Morph subclass: #SActivityMorph
	instanceVariableNames: 'label bgColor isFinished tree addedOrModifiedMethodNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!SActivityMorph class methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:06.059'!
defaultWidth

	^ SActivityMorphList defaultWidth - (SActivityMorphList defaultInset * 2)! !

!SActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:57'!
activate
	"Moves this activity in the owning list to visualize its state."

	self owner ifNotNilDo: [:activityMorphList |
		activityMorphList activateActivity: self].! !

!SActivityMorph methodsFor: 'modification recording' stamp: 'bs 12/31/2009 15:31'!
addedOrModifiedMethodNames
	^ addedOrModifiedMethodNames ifNil: [addedOrModifiedMethodNames := Set new]! !

!SActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/8/2010 19:31'!
addedOrModifiedMethods
	^ self addedOrModifiedMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ]! !

!SActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:12'!
bgColor

	^ bgColor ifNil: [^ Color transparent]! !

!SActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:12'!
bgColor: aColor

	bgColor := aColor.
	self color: self bgColor.! !

!SActivityMorph methodsFor: 'ui-building' stamp: 'bs 1/20/2010 10:30'!
buildModifiedItemsTree
	^ self buildTreeOn: #modifiedItems! !

!SActivityMorph methodsFor: 'ui-building' stamp: 'bs 7/4/2010 12:48:53.766'!
buildTreeOn: aSelectorSymbol
	| tree |
	tree := STestTree on: self list: aSelectorSymbol selected: nil changeSelected: nil.
	self addMorphBack: tree.
	self addDependent: tree.
	self invalidRect: self fullBounds.
	^ tree.! !

!SActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:55'!
contextMenu

	| menu |
	menu := MenuMorph entitled: 'Activity'.
	menu
		add: 'Activate'
		target: self
		selector: #activate
		enabled: true
		icon: nil.
	menu
		add: 'Finish'
		target: self
		selector: #finish
		enabled: true
		icon: nil.
	menu addLine.
	menu
		add: 'Delete'
		target: self
		selector: #delete
		enabled: true
		icon: nil.
	^ menu! !

!SActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:40'!
delete

	super delete.
	self changed: #activityDeleted.! !

!SActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:30'!
finish
	"Moves this activity in the owning list to visualize its state."

	self owner ifNotNilDo: [:activityMorphList |
		activityMorphList finishActivity: self].! !

!SActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:53'!
handleMouseEnter: evt
	"Hightlight the morph."

	super handleMouseEnter: evt.
	self isFinished
		ifFalse: [self color: Color blue muchLighter].! !

!SActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:12'!
handleMouseLeave: evt

	super handleMouseLeave: evt.
	self color: self bgColor.! !

!SActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:42'!
handlesMouseDown: evt

	^ true! !

!SActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 23:03'!
highlightWithColor: aColor
	"Reset the color then wait some time and restore the old one. Can be used for flashing effects."
	
	| old |
	old := self bgColor.
	self bgColor: aColor.
	[(Delay forMilliseconds: 500) wait. self bgColor: old] fork.! !

!SActivityMorph methodsFor: 'initialize-release' stamp: 'bs 1/20/2010 21:24'!
initialize
	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		layoutInset: 3;
		extent: self class defaultWidth @ 50;
		addMorph: self label;
		buildTreeOn: #modifiedItems.! !

!SActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:51'!
isFinished

	^ isFinished ifNil: [false]! !

!SActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:51'!
isFinished: aBoolean

	isFinished := aBoolean.! !

!SActivityMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isNewBehavior
	^ false! !

!SActivityMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isRefactoring
	^ false! !

!SActivityMorph methodsFor: 'accessing' stamp: 'mt 12/16/2009 11:08'!
label

	^ label ifNil: [label := TextMorph new lock; hResizing: #spaceFill]! !

!SActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/1/2010 00:45'!
methodAddedOrModified: aMethod
	self addedOrModifiedMethodNames add: aMethod qualifiedName.
	self changed: #modifiedItems.! !

!SActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 10:22'!
methodRemoved: aMethod
	self addedOrModifiedMethodNames remove: aMethod qualifiedName ifAbsent: [].
	self changed: #modifiedItems.! !

!SActivityMorph methodsFor: 'modification recording' stamp: 'bs 7/4/2010 12:48:47.68'!
modifiedItems
	
	| g groups |
	g := IdentityDictionary new.
	self addedOrModifiedMethods do: [:method |
		(g includesKey: method methodClass)
			ifFalse: [g at: method methodClass put: OrderedCollection new].
		(g at: method methodClass) add: method ].
	
	groups := OrderedCollection new.
	g associationsDo: [:group | groups add: (STestCaseItemWrapper with: group)].
	^ groups! !

!SActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:52'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	(self isFinished not and: [evt yellowButtonPressed] )
		ifTrue: [
			self contextMenu popUpInWorld.
			evt wasHandled: true].! !

!SActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 00:04'!
nonTestMethodRemoved: aMethod
	! !

!SActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 21:29'!
setLabelText: aString

	self label contentsWrapped: aString! !

!SActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 00:03'!
testMethodRemoved: aMethod
	! !

!SActivityMorph methodsFor: 'as yet unclassified' stamp: 'bs 1/2/2010 13:06'!
visualizeFinishState
	self bgColor: Color gray lighter! !

!SActivityMorph methodsFor: 'as yet unclassified' stamp: 'bs 1/2/2010 13:05'!
visualizeOpenState
	self bgColor: Color red lighter! !

SActivityMorph subclass: #SNewBehaviorMorph
	instanceVariableNames: 'testMethodName testMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!SNewBehaviorMorph methodsFor: 'as yet unclassified' stamp: 'bs 1/15/2010 22:58'!
finish
	super finish.
	self addedOrModifiedMethods do: [ :method | method fixes: self testMethod ].! !

!SNewBehaviorMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isNewBehavior
	^ true.! !

!SNewBehaviorMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 00:07'!
nonTestMethodRemoved: aMethod
	self methodRemoved: aMethod! !

!SNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethod
	^ CompiledMethod fromQualifiedName: self testMethodName! !

!SNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethod: aTestMethod
	self testMethodName: aTestMethod qualifiedName.
	self updateLabel.! !

!SNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethodName
	^ testMethodName! !

!SNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethodName: anObject
	testMethodName := anObject! !

!SNewBehaviorMorph methodsFor: 'modification recording' stamp: 'bs 1/3/2010 21:27'!
testMethodRemoved: aMethod
	(self testMethodName = aMethod qualifiedName) ifTrue: [ self owner deleteActivity: self ]! !

!SNewBehaviorMorph methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 16:48'!
updateLabel

	self setLabelText: 
		(self testMethod
			ifNil: ['n/a']
			ifNotNil: [self testMethod qualifiedName])! !

SActivityMorph subclass: #SRefactoringMorph
	instanceVariableNames: 'event brokenTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

SRefactoringMorph class
	instanceVariableNames: 'someTestCases'!

SRefactoringMorph class
	instanceVariableNames: 'someTestCases'!

!SRefactoringMorph class methodsFor: 'as yet unclassified' stamp: 'bs 12/14/2009 10:32'!
on: aCompiledMethod
	^ self new 
		method: aCompiledMethod;
		addMorph: (StringMorph contents: aCompiledMethod qualifiedName);
		extent: 200 @ 50; 
		yourself.! !

!SRefactoringMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:47.688'!
brokenTestItems
	
	| g groups |
	g := IdentityDictionary new.
	self brokenTests do: [:method |
		(g includesKey: method methodClass)
			ifFalse: [g at: method methodClass put: OrderedCollection new].
		(g at: method methodClass) add: method ].
	
	groups := OrderedCollection new.
	g associationsDo: [:group | groups add: (STestCaseItemWrapper with: group)].
	^ groups! !

!SRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:15'!
brokenTests
	^ brokenTests ifNil: [ brokenTests := Set new ]! !

!SRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:18'!
brokenTests: anObject
	brokenTests := anObject.
	self changed: #brokenTestItems! !

!SRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:11'!
event
	^ event! !

!SRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:11'!
event: anObject
	event := anObject! !

!SRefactoringMorph methodsFor: 'initialize-release' stamp: 'bs 1/20/2010 21:22'!
initialize
	super initialize.
	self buildTreeOn: #brokenTestItems.! !

!SRefactoringMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isRefactoring
	^ true.! !

!SRefactoringMorph methodsFor: 'updating' stamp: 'bs 1/20/2010 21:12'!
updateLabel

	self setLabelText: 
		(self event
			ifNil: ['n/a']
			ifNotNil: [self event asString])! !

Morph subclass: #SActivityMorphList
	instanceVariableNames: 'separator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!SActivityMorphList class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:06'!
defaultInset

	^ 0! !

!SActivityMorphList class methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:44.919'!
defaultWidth
	"Calculate the correct width out of default values of the environment."

	^ STddMonitor defaultWidth
	 - SwaGeneralScrollPane defaultScrollbarThickness
	 - (STddMonitor defaultInset * 2)! !

!SActivityMorphList class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:25'!
numberOfFinishedTasksToKeep

	^ 4! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'mt 12/15/2009 23:00'!
activateActivity: anActivityMorph
	"Changes the position of the given activity morph to visualize its state."

	self
		removeMorph: anActivityMorph;
		addMorph: anActivityMorph after: self separator.
		
	anActivityMorph highlightWithColor: Color yellow.! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/3/2010 17:00'!
activatedActivity
	| separatorIndex |
	separatorIndex := self submorphIndexOf: self separator.
	^ (separatorIndex = self submorphs size)
		ifTrue: [nil]
		ifFalse: [self submorphs at: separatorIndex + 1].! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'bs 7/4/2010 12:48:05.26'!
activities

	^ self submorphs select: [ :ea | ea isKindOf: SActivityMorph ]! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/2/2010 13:09'!
addActivity: anActivityMorph

	self addMorph: anActivityMorph behind: self separator.
	anActivityMorph 
		addDependent: self;
		visualizeOpenState;
		isFinished: false.! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/3/2010 21:22'!
deleteActivity: anActivityMorph

	anActivityMorph delete! !

!SActivityMorphList methodsFor: 'private' stamp: 'mt 12/15/2009 22:29'!
discardOldActivities
	"Only keep a specific number of finished activities in the list."
	
	| behind frontMorphs |
	behind := false.
	frontMorphs := OrderedCollection new.
	
	self submorphs do: [:morph |
		morph == self separator
			ifTrue: [behind := true]
			ifFalse: [behind ifFalse: [frontMorphs add: morph]]].
		
	[frontMorphs size > self class numberOfFinishedTasksToKeep]
		whileTrue: [self removeMorph: frontMorphs first. frontMorphs remove: frontMorphs first]! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/2/2010 13:06'!
finishActivity: anActivityMorph
	"Changes the position of the given activity morph to visualize its state."

	self
		removeMorph: anActivityMorph;
		addMorph: anActivityMorph inFrontOf: self separator;
		discardOldActivities.
		
	anActivityMorph
		visualizeFinishState;
		isFinished: true;
		highlightWithColor: Color yellow.! !

!SActivityMorphList methodsFor: 'initialization' stamp: 'mt 12/15/2009 22:08'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		layoutInset: self class defaultInset;
		cellInset: 5;
		extent: self class defaultWidth @ 10;
		color: Color transparent;
		addMorph: self separator.! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'mt 12/16/2009 11:23'!
privateAddMorph: aMorph atIndex: index

	super privateAddMorph: aMorph atIndex: index.
	self invalidRect: self fullBounds.
	self changed: #resized.! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'mt 12/15/2009 21:54'!
refactoringActivityOn: aCompiledMethod
	"Return the submorph based of the given method."

	^ self submorphs detect: [:s | s method = aCompiledMethod]! !

!SActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/2/2010 13:09'!
reopenActivity: anActivityMorph
	"Changes the position of the given activity morph to visualize its state."

	self
		removeMorph: anActivityMorph;
		addMorph: anActivityMorph behind: self separator;
		discardOldActivities.
		
	anActivityMorph
		visualizeOpenState;
		isFinished: false;
		highlightWithColor: Color yellow.! !

!SActivityMorphList methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:05.253'!
separator
	"Separator to seperate open and closed activities."

	^ separator ifNil: [separator :=
		Morph new
			extent: SActivityMorph defaultWidth @ 2;
			color: (Color black alpha: 0.5)]! !

!SActivityMorphList methodsFor: 'updating' stamp: 'mt 12/16/2009 11:39'!
update: aSymbol

	aSymbol = #activityDeleted
		ifTrue: [
			self invalidRect: self fullBounds.
			self changed: #resized]! !

Morph subclass: #STddMonitor
	instanceVariableNames: 'list csTestRunner'
	classVariableNames: 'Inst'
	poolDictionaries: ''
	category: 'SightC-Driving'!

!STddMonitor class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:48'!
defaultHeight

	^ 500! !

!STddMonitor class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:53'!
defaultInset

	^ 7! !

!STddMonitor class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:48'!
defaultWidth

	^ 200! !

!STddMonitor class methodsFor: 'instance creation' stamp: 'bs 12/22/2009 16:34'!
open

	^ self new open.! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 7/4/2010 12:48:36.731'!
addRefactoringActivityOn: aCompiledMethod withTests: someTestCases

	self list addActivity: (SRefactoringMorph new
		method: aCompiledMethod;
		tests: someTestCases).! !

!STddMonitor methodsFor: 'building' stamp: 'bs 1/3/2010 18:39'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; "label: self label; extent: self extent;"
		"children: (OrderedCollection new 
			add: ((self buildItemListWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 1.0 @ 1.0 );
				yourself);
			yourself);"
		yourself.
	^ aBuilder build: window.! !

!STddMonitor methodsFor: 'accessing' stamp: 'replica 5/20/2010 20:39:26.828'!
csTestRunner
	^ csTestRunner! !

!STddMonitor methodsFor: 'accessing' stamp: 'replica 5/20/2010 20:39:26.84'!
csTestRunner: anObject
	csTestRunner := anObject! !

!STddMonitor methodsFor: 'event handling' stamp: 'replica 5/20/2010 20:41:33.067'!
handle: aCsEvent
	self csTestRunner handle: aCsEvent! !

!STddMonitor methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:53'!
initialize
	
	super initialize.
	self
		borderWidth: 0;
		color: (Color gray alpha: 0.5);
		changeTableLayout;
		layoutInset: self class defaultInset;
		listDirection: #topToBottom;
		initializeList.! !

!STddMonitor methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:07.367'!
initializeList
	
	| scroller |
	scroller := SActivityScroller new.
	self addMorph: scroller.
	self list: scroller scrollTarget.! !

!STddMonitor methodsFor: 'accessing' stamp: 'bs 12/22/2009 16:38'!
list
	^ list! !

!STddMonitor methodsFor: 'accessing' stamp: 'mt 12/15/2009 21:58'!
list: anObject
	list := anObject! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 1/18/2010 09:32'!
modification: aCsEvent brokeTests: testMethods
	! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 7/4/2010 12:48:32.154'!
newBehaviorSpecified:  aTestMethod 
	| activity |
	activity := self list activities 
		detect: [ :ea | ea isNewBehavior and: [ ea testMethod qualifiedName = aTestMethod qualifiedName ] ]
		ifNone: [ nil ].
	
	activity
		ifNil: [ self list addActivity: (SNewBehaviorMorph new testMethod: aTestMethod) ]
		ifNotNil: [ self list reopenActivity: activity ].! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 1/3/2010 22:27'!
nonTestMethodAddedOrModified: aMethod
	self list activatedActivity ifNotNilDo: [ :activity | 
		activity methodAddedOrModified: aMethod ]! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 00:12'!
nonTestMethodRemoved: aMethod
	self list activities do: [ :ea | ea nonTestMethodRemoved: aMethod ]
	! !

!STddMonitor methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:57'!
open

	self
		openInWorld;
		extent: self class defaultWidth @ self class defaultHeight.! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 1/3/2010 21:10'!
reset
	self list activities do: [ :ea | self list deleteActivity: ea ].! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 00:12'!
testMethodRemoved: aMethod
	self list activities do: [ :ea | ea testMethodRemoved: aMethod ]! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 12/22/2009 20:03'!
testsTurnedGreen: testMethods
	| testMethodNames |
	testMethodNames := testMethods collect: [ :ea | ea qualifiedName ].
	self list activities 
		select: [ :ea | ea isNewBehavior and: [ testMethodNames includes: ea testMethod qualifiedName ]]
		thenDo: [ :ea | ea finish ].! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 7/4/2010 12:48:32.163'!
unsupportedTestSpecified:  aTestMethod 
	| activity |
	activity := self list activities 
		detect: [ :ea | ea isNewBehavior and: [ ea testMethod qualifiedName = aTestMethod qualifiedName ] ]
		ifNone: [ nil ].
	
	activity
		ifNil: [ self list addActivity: (SNewBehaviorMorph new testMethod: aTestMethod) ]
		ifNotNil: [ self list reopenActivity: activity ].! !

!STddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 14:34'!
unsupportedTestsSpecified:  testMethods
	testMethods do: [ :ea | self unsupportedTestSpecified: ea ].! !

SwaGeneralScrollPane subclass: #SActivityScroller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!SActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:46'!
hScrollbarNeeded
	"Never show the horizontal scrollbar."
	
	^ false! !

!SActivityScroller methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:06.051'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		scrollTarget: SActivityMorphList new.
		
	self scrollTarget addDependent: self.! !

!SActivityScroller methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:06.713'!
newVScrollbar
	"Answer a new vertical scrollbar."

	^SActivityScrollBar new
		model: self;
		setValueSelector: #vScrollbarValue:! !

!SActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 21:14'!
update: aSymbol

	aSymbol = #resized
		ifTrue: [self updateScrollbars]! !

!SActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:46'!
vScrollbarNeeded
	"Always show the vertical scrollbar."

	^ true! !

SMethodExtension subclass: #SCstMethodExtension
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'SightC-Cst'!

!SCstMethodExtension class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:32:28.733'!
instance
	^ Instance ifNil: [ Instance := super new ]! !

!SCstMethodExtension class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:32:16.96'!
new
	^ (self = SCstMethodExtension) 
		ifTrue: [ self instance ]
		ifFalse: [ super new ]! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:59:16.448'!
calledMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:38.556'!
coveredMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:48.841'!
coveredMethodsStatistics
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:57:48.206'!
coveringAndNotFixedTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:57:30.543'!
coveringTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:04.25'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	^ Array empty! !

!SCstMethodExtension methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:11:21.749'!
doesNotUnderstand: aMessage
	(self class subclasses anySatisfy: [ :c | c canUnderstand: aMessage selector ])
		ifFalse: [ self error: 'cst method extensions fail to support this message' ]! !

!SCstMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/18/2010 12:15:50.529'!
fixedTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:55:23.83'!
hasCoveringTestMethods
	^ false! !

!SCstMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/18/2010 12:16:01.621'!
hasFixedTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'accessing' stamp: 'bs 7/5/2010 08:35:48.717'!
pvtCodeSightMonitor
	^ SCodeSight sourceCodeMonitor! !

SCstMethodExtension subclass: #SNonTestMethodExtension
	instanceVariableNames: 'codeSight coveringTestMethods fixedTestMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Cst'!

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 1/16/2010 21:00'!
beforeMethod

	self flag: #rkrk. "for benchmarking"
	self ifActive: [
		self codeSight runningTestMethod called: self clientMethod ]! !

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 7/5/2010 11:14:52.504'!
beforeMethodWithReceiver: anObject 
	codeSight runningTestMethod
		ifNotNilDo: [ :runningTestMethod |
			self calledBy: runningTestMethod receiverClass: anObject class ]! !

!SNonTestMethodExtension methodsFor: 'coverage tracing' stamp: 'bs 7/4/2010 21:20:00.58'!
calledBy: aTestMethod receiverClass: aClass 
	self pvtCoveringTestMethods add: aTestMethod.
	aTestMethod privateCovered: clientMethod withReceiverClass: aClass! !

!SNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:00'!
codeSight
	^ codeSight! !

!SNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:00'!
codeSight: anObject
	codeSight := anObject! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringAndNotFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtCoveringTestMethods copy.
		"fixed link might be established and coverage not yet"
		result removeAllFoundIn: self pvtFixedTestMethods ].
	^ result ! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods copy ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:32'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods 
			select: [ :testMethod | 
				(testMethod privateStatisticsForCoveredMethod: self unwrappedMethod) 
					receiverClasses includes: aClass ] ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtFixedTestMethods copy ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixes: aCompiledTestMethod 
	self fixesAll: {aCompiledTestMethod}! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixesAll: compiledTestMethods 
	self pvtCodeSightMonitor critical: [
		self pvtFixedTestMethods addAll: compiledTestMethods ]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
hasCoveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods isEmpty not ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
hasFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtFixedTestMethods isEmpty not ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 1/16/2010 22:24'!
ifActive: aBlock
	self isActive ifTrue: [aBlock value]! !

!SNonTestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:13:19.001'!
initialize
	super initialize.
	coveringTestMethods := KeyedIdentitySet
				keyBlock: [:t1 | t1 scaledIdentityHash]! !

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 1/16/2010 22:24'!
isActive
	^ self codeSight isTracingActivated! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
privateAddCoveringTestMethod: aCompiledTestMethod
	^ self pvtCoveringTestMethods add: aCompiledTestMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:29'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod ifAbsent: []! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:06:56.071'!
pvtCoveringTestMethods
	^ coveringTestMethods 
		ifNil: [ coveringTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/22/2010 10:15'!
pvtFixedTestMethods
	^ fixedTestMethods 
		ifNil: [fixedTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ]]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetCoveringTestMethods
	coveringTestMethods := nil! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetFixedTestMethods
	fixedTestMethods := nil! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeCoveringTestMethod: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		"the other direction is removed by the sender"
		self privateRemoveCoveringTestMethod: aTestCaseMethod ]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		(self pvtFixedTestMethods includes: aTestCaseMethod) ifFalse: [^ self].
		(self pvtCoveringTestMethods includes: aTestCaseMethod) ifTrue: [^ self].
		self pvtFixedTestMethods remove: aTestCaseMethod ]
	! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:10'!
resetAllCoverageData
	self 
		resetCoveringTestMethods;
		resetFixedTestMethods.! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:11'!
resetCoveringTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtCoveringTestMethods do: [:testMethod |
			testMethod privateRemoveCoveredMethod: self unwrappedMethod ].
		self pvtResetCoveringTestMethods ].! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
resetFixedTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtResetFixedTestMethods ].! !

SCstMethodExtension subclass: #STestMethodExtension
	instanceVariableNames: 'coveredMethodsStatistics calledMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Cst'!

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:53:25.565'!
called: aCompiledMethod

	self flag: #rkrk. "for benchmarking"
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { }  ]! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:52:43.762'!
called: aCompiledMethod receiver: anObject 
	
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { anObject class }  ].! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:51:41.557'!
called: aCompiledMethod receiverClasses: classes 

	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: classes ].! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:52'!
calledMethods
	^ calledMethods ifNil: [ calledMethods := OrderedIdentityCollection new  ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:12'!
coveredMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics keys ].
	^ result! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:05'!
coveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics copy ].
	^ result! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 4/23/2010 10:34:11.8'!
hasCoveringTestMethods
	^ false! !

!STestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:12:21.388'!
initialize
	super initialize.
	coveredMethodsStatistics := OrderedKeysIdentityDictionary new! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/4/2010 21:19:49.989'!
privateCovered: aCompiledAppMethod withReceiverClass: aClass
	| statistic |
	statistic := self pvtCoveredMethodsStatistics 
				at: aCompiledAppMethod
				ifAbsentPut: [ STestStatistic new ].
	statistic addReceiverClass: aClass.
	self calledMethods add: aCompiledAppMethod.! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:28'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:06'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self pvtCoveredMethodsStatistics at: aCompiledMethod ! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'bs 7/5/2010 11:33:21.544'!
pvtCalled: aCompiledMethod receiverClasses: classes 
	| statistic |
	aCompiledMethod privateAddCoveringTestMethod: self clientMethod.
		
	statistic := self pvtCoveredMethodsStatistics 
			at: aCompiledMethod
			ifAbsentPut: [ STestStatistic new ].
	statistic addReceiverClasses: classes.! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:09:05.391'!
pvtCoveredMethodsStatistics
	^  coveredMethodsStatistics 
		ifNil: [ coveredMethodsStatistics := OrderedKeysIdentityDictionary new ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtResetCoveredMethodsStatistics
	coveredMethodsStatistics := nil! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
removeCoveredMethod: aCompiledAppMethod
	self pvtCodeSightMonitor critical: [
		self privateRemoveCoveredMethod: aCompiledAppMethod ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:08'!
resetAllCoverageData
	self resetCoveredMethodsStatistics! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:46'!
resetCoveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: [
		self pvtCoveredMethodsStatistics keysDo: [ :coveredMethod | 
				coveredMethod privateRemoveCoveringTestMethod: self unwrappedMethod. ].
	
		result := self pvtResetCoveredMethodsStatistics. 
		calledMethods := nil ].
	^ result! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:09'!
statisticsForCoveredMethod: aCompiledMethod 
	| result |
	self pvtCodeSightMonitor critical: [
		result := self privateStatisticsForCoveredMethod: aCompiledMethod  ].
	^ result! !

TestCase subclass: #SBenchmarkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SBenchmarkTest class methodsFor: 'as yet unclassified' stamp: 'bs 10/11/2009 22:12'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!SBenchmarkTest methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.884'!
testFirstnameAccessors
	
	| aPerson aName |
	aPerson := STbPerson new.
	aName := 'Bastian'.
	aPerson firstname: aName.
	self assert: aPerson firstname = aName.! !

TestCase subclass: #STddMonitorTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!STddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:44.906'!
setUp
	super setUp.
	sut := STddMonitor open.! !

!STddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 16:37'!
tearDown
	sut delete.
	super tearDown.! !

!STddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.636'!
testNewBehaviorRespecified
	| testMethod testMethod2 |
	testMethod := STbPersonTest >> #testFailing.
	testMethod2 := STbPersonTest >> #testFirstnameAccessors.
	sut newBehaviorSpecified: testMethod.
	sut newBehaviorSpecified: testMethod2.
	
	STbPersonTest recompile: #testFirstnameAccessors.
	testMethod2 := STbPersonTest >> #testFirstnameAccessors.
	sut newBehaviorSpecified: testMethod2.
	
	self assert: [ sut list activities size == 2 ].
	self assert: [ sut list activities first testMethod = testMethod2 ].! !

!STddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.644'!
testNewBehaviorSpecified
	| testMethod testMethod2 |
	testMethod := STbPersonTest >> #testFailing.
	testMethod2 := STbPersonTest >> #testFirstnameAccessors.
	sut newBehaviorSpecified: testMethod.
	sut newBehaviorSpecified: testMethod2.
	self assert: [ sut list activities size == 2 ].
	self assert: [ sut list activities first label text asString = testMethod2 qualifiedName ]! !

!STddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:44.9'!
testOpenTddMonitor
	| monitorWindow |
	monitorWindow := STddMonitor open.
	monitorWindow delete.! !

!STddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.651'!
testReset
	| testMethod |
	testMethod := STbPersonTest >> #testFailing.
	sut newBehaviorSpecified: testMethod.
	self assert: [ sut list activities size == 1 ].
	sut reset.
	self assert: [ sut list activities size == 0 ].! !

TestCase subclass: #STestResultCopyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-DistributionTests'!

!STestResultCopyTest methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.69'!
testCopy
	| sut aTest theCopy |
	sut := TestResult new.
	aTest := STbPersonTest selector: #testFailing.
	aTest fooBar: 'Hello'.
	self should: [ aTest fooBar = 'Hello' ].
	(sut instVarNamed: 'passed') add: aTest.
	
	theCopy := sut copy.
	self should: [ theCopy passed size = 1 ].
	self should: [ theCopy passed asArray first fooBar = nil ].! !

!TestCase methodsFor: '*SightC' stamp: 'bs 12/21/2009 17:45'!
currentTestCaseMethod
	^ self class >> self selector! !

!TestCase methodsFor: '*SightC' stamp: 'bs 12/21/2009 17:45'!
recordRunFailedWith: anException
	self currentTestCaseMethod testFailedWith: anException.
	
	! !

!TestCase methodsFor: '*SightC' stamp: 'bs 12/21/2009 17:46'!
recordRunWasSuccessful
	self currentTestCaseMethod testWasSuccessful! !

!Symbol methodsFor: '*SightC' stamp: 'bs 9/10/2009 08:54'!
isTestSelector
	^ (self last ~= $:) and: ['test*' match: self]! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:46:25.893'!
called: aCompiledMethod
	self cstMethodExtension called: aCompiledMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:46:36.386'!
called: aCompiledMethod receiver: anObject 
	self cstMethodExtension called: aCompiledMethod receiver: anObject ! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:46:43.765'!
called: aCompiledMethod receiverClasses: classes 
	self cstMethodExtension called: aCompiledMethod receiverClasses: classes ! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:46:48.272'!
coveredMethods
	^ self cstMethodExtension coveredMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:46:55.863'!
coveredMethodsStatistics
	^ self cstMethodExtension coveredMethodsStatistics! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:47:00.904'!
coveringAndNotFixedTestMethods
	^ self cstMethodExtension coveringAndNotFixedTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:47:05.66'!
coveringTestMethods
	^ self cstMethodExtension coveringTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:47:09.466'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	^ self cstMethodExtension coveringTestMethodsWhenReceiverWasOfKind: aClass ! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:00:14.561'!
cstMethodExtension
	^ self hasMethodExtension
		ifTrue: [ self methodExtension ]
		ifFalse: [ SCstMethodExtension new ]! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/31/2009 16:27'!
failedExpression
	| interval |
	interval := self failedExpressionInterval.
	^ self getSource asString copyFrom: interval first to: interval last.! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/31/2009 16:06'!
failedExpressionInterval
	^ self properties at: #codeSightFailedExpression ifAbsent: [ nil ]! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/31/2009 16:19'!
failedExpressionInterval: aSelectionInterval
	self properties at: #codeSightFailedExpression put: aSelectionInterval.! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/22/2009 18:24'!
findTestMethodInStack: anException
	^ anException signalerContext contextStack 
		detect: [:aMethodContext | aMethodContext method = self]
		ifNone: [nil]! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:47:16.202'!
fixedTestMethods
	^ self cstMethodExtension fixedTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:47:24.027'!
fixes: aCompiledTestMethod 
	^ self cstMethodExtension fixes: aCompiledTestMethod ! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 11:47:28.202'!
fixesAll: compiledTestMethods
	^ self cstMethodExtension fixesAll: compiledTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:00:26.133'!
hasCoveringTestMethods
	^ self cstMethodExtension hasCoveringTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:27'!
hasFixedTestMethods
	^ self methodExtension hasFixedTestMethods! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/21/2009 15:58'!
hasTestFailed
	^ self properties includesKey: #codeSightFailedExpression
	! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 11/27/2009 10:41'!
isTestMethod
	^ (self methodClass inheritsFrom: TestCase) and: [self selector isTestSelector]! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:07'!
newTestCase
	self assert: [ self isTestMethod ].
	
	^ self methodClass selector: self selector.! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 11/27/2009 11:05'!
overriddenAndOverridingMethods
	^ self overriddenAndOverridingMethodsIn: self methodClass! !

!CompiledMethod methodsFor: '*SightC' stamp: 'test 9/20/2009 21:39'!
overriddenAndOverridingMethodsIn: aClass
	|result|
	result := (self overridingMethodsIn: aClass) copy.
	(self overriddenMethodIn: aClass) 
		ifNotNilDo: [:aMethod | result add: aMethod].
	^ result! !

!CompiledMethod methodsFor: '*SightC' stamp: 'test 9/20/2009 21:34'!
overriddenMethod
	^ self overriddenMethodIn: self methodClass! !

!CompiledMethod methodsFor: '*SightC' stamp: 'test 9/20/2009 21:49'!
overriddenMethodIn: aClass
	^ (aClass superclass whichClassIncludesSelector: self selector)
			ifNotNilDo: [ :superclass | (superclass >> self selector) clientMethod ]
			ifNil: [ nil ].! !

!CompiledMethod methodsFor: '*SightC' stamp: 'test 9/20/2009 21:34'!
overridingMethods
	^ self overridingMethodsIn: self methodClass! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 11/27/2009 10:54'!
overridingMethodsIn: aClass
	| overriders |
	overriders := Set new.
	self methodClass addOverridersOf: self selector to: overriders.
	
	^ overriders collect: [ :overrider | 
			(overrider >> self selector) clientMethod ]! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:00:41.683'!
privateAddCoveringTestMethod: aCompiledTestMethod
	self cstMethodExtension privateAddCoveringTestMethod: aCompiledTestMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:00:48.316'!
privateCovered: aCompiledAppMethod withReceiverClass: aClass
	self cstMethodExtension privateCovered: aCompiledAppMethod withReceiverClass: aClass! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:00:53.065'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self cstMethodExtension privateRemoveCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:10.502'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	self cstMethodExtension privateRemoveCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:24.333'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self cstMethodExtension privateStatisticsForCoveredMethod: aCompiledMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:31'!
pvtCodeSightMonitor! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:31'!
pvtCoveredMethodsStatistics! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:31'!
pvtCoveringTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:31'!
pvtFixedTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:32'!
pvtRemoveCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/16/2010 20:32'!
pvtRemoveCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:28.592'!
removeCoveredMethod: aCompiledAppMethod
	^ self cstMethodExtension removeCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:32.717'!
removeCoveringTestMethod: aTestCaseMethod
	^ self cstMethodExtension removeCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:36.814'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	^ self cstMethodExtension removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 1/17/2010 14:40'!
resetAllCoverageData
	^ self methodExtension: nil! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:41.055'!
resetCoveredMethodsStatistics
	^ self cstMethodExtension resetCoveredMethodsStatistics! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:45.467'!
resetCoveringTestMethods
	^ self cstMethodExtension resetCoveringTestMethods! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/21/2009 12:57'!
resetFailedExpression
	self properties removeKey: #codeSightFailedExpression ifAbsent: [].! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:49.949'!
resetFixedTestMethods
	^ self cstMethodExtension resetFixedTestMethods! !

!CompiledMethod methodsFor: '*SightC' stamp: 'bs 7/18/2010 12:01:54.528'!
statisticsForCoveredMethod: aCompiledMethod 
	^ self cstMethodExtension statisticsForCoveredMethod: aCompiledMethod ! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/31/2009 16:24'!
testFailedWith: anException
	| testMethodContext pc pcRange | 
	testMethodContext := self findTestMethodInStack: anException.
	testMethodContext
		ifNotNil: [
			pc := testMethodContext pc.
			pcRange := testMethodContext debuggerMap 
				rangeForPC: pc contextIsActiveContext: false.
			self failedExpressionInterval: pcRange ].! !

!CompiledMethod methodsFor: '*SightC-FailedExpression' stamp: 'bs 12/21/2009 15:51'!
testWasSuccessful
	self resetFailedExpression! !

CompiledMethod variableByteSubclass: #SInstrumentedMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!SInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 7/4/2010 12:47:12.267'!
activateBefore: methodIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := SWeavingInstrumentor extensionAtIndex: methodIndex.
	aMethodExtension codeSight activateTracing.! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.264'!
activationOn: aSelectorSymbol inClass: aClass
	| originalMethod decompiledMethodNode methodNode aroundCodeNode wrappedStatements statementToAdd instrumentedMethod originalStatements |
	
	originalMethod := aClass >> aSelectorSymbol.
	decompiledMethodNode := originalMethod decompile.
	decompiledMethodNode instVarNamed: 'properties' put: nil.
	methodNode := Parser new parse: decompiledMethodNode asString class: aClass.
	
	aroundCodeNode := self createActivationAroundCodeFor: originalMethod.
	wrappedStatements := aroundCodeNode "return" expr "ensure" receiver "block" statements. 
	
	originalStatements := methodNode body statements copy.
	methodNode body statements removeAll: originalStatements.
	
	originalStatements do: [  :st | 
		statementToAdd := (st isKindOf: ReturnNode) ifTrue: [ st expr ] ifFalse: [ st ] .
		wrappedStatements add: statementToAdd ].
	
	methodNode body statements addFirst: aroundCodeNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:47:12.281'!
createActivationAroundCodeFor: aCompiledMethod
	| extIndex aroundCode aroundCodeMethodNode |
	extIndex := SWeavingInstrumentor indexForExtension: aCompiledMethod methodExtension.
	
	aroundCode := 
		'^ [',
			'(' , SWeavingInstrumentor asString , ' calleeAtIndex: ' , extIndex asString , ')' ,
			'     codeSight activateTracing.',
		'] ensure: [',
			'(' , SWeavingInstrumentor asString , ' methodExtensionAtIndex: ' , extIndex asString , ')' ,
			'     codeSight deactivateTracing.',
		']'.
	
	aroundCodeMethodNode := Parser new parse: 'foo ', aroundCode class: Object.
	^ aroundCodeMethodNode body statements first! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:47:12.289'!
createTraceCallFor: aCompiledMethod
	| extIndex traceCallString tmpMethodNode |
	extIndex := SWeavingInstrumentor indexForExtension: aCompiledMethod methodExtension.
	
	traceCallString := 
		'(' , SWeavingInstrumentor asString , ' calleeAtIndex: ' , extIndex asString , ')' ,
		'     calledByRunningTestWithReceiver: self'.

	tmpMethodNode := Parser new parse: 'foo ' , traceCallString class: Object.
	^ tmpMethodNode body statements first! !

!SInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 7/4/2010 12:47:12.274'!
deactivateAfter: calleeIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := SWeavingInstrumentor extensionAtIndex: calleeIndex.
	aMethodExtension codeSight deactivateTracing.! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/5/2010 11:42:57.148'!
on: aSelectorSymbol inClass: aClass
	| originalMethod methodNode traceCallNode instrumentedMethod |
	
	originalMethod := aClass >> aSelectorSymbol.
	methodNode := self parseSource: originalMethod.
	
	traceCallNode := self createTraceCallFor: originalMethod.
	methodNode body statements addFirst: traceCallNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.325'!
parseSource: aCompiledMethod
	| source |
	source := aCompiledMethod getSource.
	^ Parser new parse: source class: aCompiledMethod methodClass.
	! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.15'!
clientMethod
	^ self originalMethod! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.162'!
compiledMethod
	^ self originalMethod! !

!SInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.218'!
install
	self methodClass addSelectorSilently: self selector withMethod: self.! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.173'!
methodExtension
	^ self originalMethod methodExtension! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.184'!
methodExtension: anObject
	^ self originalMethod methodExtension: anObject! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.195'!
originalMethod
	^ self properties at: #codeSightOriginalMethod ifAbsent: [ nil ]! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.207'!
originalMethod: aCompiledMethod
	self properties at: #codeSightOriginalMethod put: aCompiledMethod! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 7/5/2010 08:38:34.002'!
resetMethodExtension
	self methodExtension: nil! !

!SInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.229'!
uninstall
	(self methodClass includesSelector: self selector)
		ifTrue: [
			 self methodClass 
				addSelectorSilently: self selector 
				withMethod: self originalMethod. ]! !

TextAttribute subclass: #STextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Text'!

!STextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color
	^ color! !

!STextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color: anObject
	color := anObject! !

!STextBackgroundColor methodsFor: 'displaying' stamp: 'bs 12/21/2009 17:03'!
emphasizeBackground: bounds on: aCanvas
	aCanvas 
		fillRectangle: bounds
		color: self color.! !

!STextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/21/2009 17:34'!
shoutShouldPreserve
	^ true! !

!STextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 18:22'!
writeScanOn: strm
	! !

!TextAttribute methodsFor: '*SightC' stamp: 'bs 12/21/2009 17:01'!
emphasizeBackground: bounds on: aCanvas
	"Subclasses may override"! !

!Behavior methodsFor: '*SightC' stamp: 'bs 10/28/2009 10:03'!
addOverridersOf: aSelector to: aCollection
	self allSubclassesDo: [:subclass | 
		(subclass includesSelector: aSelector)
			ifTrue: [aCollection add: subclass]
			ifFalse: [subclass addOverridersOf: aSelector to: aCollection]]! !

SwaGeneralScrollBar subclass: #SActivityScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Driving'!

!SActivityScrollBar methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:55'!
initializeMenuButton
	"Ignore menu button."
	
	menuButton := nil.! !

!MethodNode methodsFor: '*SightC' stamp: 'bs 3/4/2010 22:53:54.075'!
generate: trailer using: aCompiledMethodClass
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."

	| literals blkSize method nArgs nLits primErrNode stack strm |
	self generate: trailer ifQuick: 
		[:m |
		literals := encoder allLiterals.
		(nLits := literals size) > 255 ifTrue:
			[^self error: 'Too many literals referenced'].
		1 to: nLits do: [:lit | m literalAt: lit put: (literals at: lit)].
		m properties: properties.
		^m].
	primErrNode := self primitiveErrorVariableName ifNotNil:
						[encoder fixTemp: self primitiveErrorVariableName].
	nArgs := arguments size.
	blkSize := (block sizeForEvaluatedValue: encoder)
				+ (primErrNode ifNil: [0] ifNotNil: [2 "We force store-long (129)"]).
	(nLits := (literals := encoder allLiterals) size) > 255 ifTrue:
		[^self error: 'Too many literals referenced'].
	
	method := aCompiledMethodClass	"Dummy to allocate right size"
				newBytes: blkSize
				trailerBytes: trailer 
				nArgs: nArgs
				nTemps: encoder maxTemp
				nStack: 0
				nLits: nLits
				primitive: primitive.
	strm := ReadWriteStream with: method.
	strm position: method initialPC - 1.
	stack := ParseStack new init.
	primErrNode ifNotNil: [primErrNode emitStore: stack on: strm].
	block emitForEvaluatedValue: stack on: strm.
	stack position ~= 1 ifTrue:
		[^self error: 'Compiler stack discrepancy'].
	strm position ~= (method size - trailer size) ifTrue:
		[^self error: 'Compiler code size discrepancy'].
	method needsFrameSize: stack size.
	1 to: nLits do: [:lit | method literalAt: lit put: (literals at: lit)].
	method properties: properties.
	^method! !

!MethodNode methodsFor: '*SightC' stamp: 'bs 3/4/2010 22:24:39.64'!
generateUsing: aCompiledMethodClass
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."
	
	^ self generate: CompiledMethodTrailer empty using: aCompiledMethodClass! !

Actor subclass: #SActor
	instanceVariableNames: 'codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Distribution'!

!SActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.096'!
codeSight
	^ codeSight! !

!SActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.097'!
codeSight: anObject
	codeSight := anObject! !

!SActor methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 21:20:59.344'!
recipient
	^ self codeSight! !

STbTestCase subclass: #SCTestBase
	instanceVariableNames: 'registeredPackages unregisteredPackages tddAutoRunTestRunner codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

SCTestBase subclass: #SAsyncAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:52.41'!
testRunInBackground

	SAsyncExampleTest resetCollectedMessages.
	self should: [ SAsyncExampleTest collectedMessagesAsString = '' ].
	
	self csTestRunner runSuite: SAsyncExampleTest exampleSuite.
	self should: [ SAsyncExampleTest collectedMessagesAsString = 'Hello' ].
	
	SAsyncExampleTest resetCollectedMessages.
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: SAsyncExampleTest backgroundExampleSuite.
	(Delay forMilliseconds: 200) wait.
	STestRunner sourceCodeAccessMonitor critical: [ 
		SAsyncExampleTest addMessage: 'World'. ].
	self should: [ SAsyncExampleTest collectedMessagesAsString = 'HelloWorld' ].
	self csTestRunner disableRunningTestsInBackground.! !

!SAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:09.981'!
testRunningExampleSuite
	SAsyncExampleTest resetCollectedMessages.
	self csTestRunner runSuite: (SAsyncExampleTest exampleSuite).
	self should: [SAsyncExampleTest collectedMessagesAsString = 'Hello']. ! !

SCTestBase subclass: #SAsyncExampleTest
	instanceVariableNames: ''
	classVariableNames: 'CollectedMessages'
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:07'!
addMessage: aString
	self collectedMessages add: aString.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:43'!
backgroundExampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testRunExampleInBackground).
	^ aSuite.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:02'!
collectedMessages
	^ CollectedMessages ifNil: [CollectedMessages := OrderedCollection new.]! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:05'!
collectedMessagesAsString
	| stream |
	stream := WriteStream with: String new.
	self collectedMessages do: [: elem | stream nextPutAll: elem].
	^ stream contents! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:39'!
exampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testExample).
	^ aSuite.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:03'!
resetCollectedMessages
	CollectedMessages := nil.! !

!SAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:36'!
testExample
	self class addMessage: 'Hello'! !

!SAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:09.974'!
testRunExampleInBackground
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: (SAsyncExampleTest exampleSuite).! !

SCTestBase subclass: #SAutoTddTestBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:36:36.356'!
createSuperCallTestCode
	^ 'testSuperCall', String crlf, String tab, 'STbPersonSubclass new asString'.! !

!SAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:26:07.824'!
setUp
	super setUp.
	self csTestRunner 
		tddMonitor: STddMonitor new;
		tddAutoRunStart.
	
	self undoInTearDownDo: [
		self tracePackage: self tbPackage ].! !

!SAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 17:37'!
tearDown
	self csTestRunner 
		tddAutoRunStop;
		disableRunningTestsInBackground.
	
	super tearDown.! !

SAutoTddTestBase subclass: #SDistributionRequestTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-DistributionTests'!

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:16.027'!
codeSightClass
	^ SCodeSightForDistributionRequestTests! !

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.904'!
testRequestForCoverageMaintenance
	| testMethodsToRun testMethodNames actor coverageData |
	testMethodsToRun := { self exampleTestMethod }.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self codeSight activateTracing.
	self codeSight maintainCoverage: testMethodNames.
	
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestCoverage isEmpty ].
	coverageData := actor receivedTestCoverage at: self exampleTestMethod qualifiedName.
	self should: [ (coverageData at: self exampleMethod qualifiedName) includes: STbPerson name ].
	! !

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.451'!
testRequestForTesting
	| testMethodsToRun testMethodNames actor |
	testMethodsToRun := STbPersonTest testMethods.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self codeSight runTests: testMethodNames.
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestResult passed isEmpty ].
	self shouldnt: [ actor receivedTestResult failures isEmpty ].! !

SAutoTddTestBase subclass: #SDistributionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-DistributionTests'!

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/25/2010 08:27:21.659'!
createExampleCoverageData
	| testsToCoverageData coverageData | 
	testsToCoverageData := Dictionary new.
	coverageData := testsToCoverageData 
			at: self exampleTestMethod qualifiedName
			put: Dictionary new.
	coverageData 
		at: (self exampleMethod qualifiedName)
		put: {self exampleMethod methodClass name}.
	
	^ testsToCoverageData.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.459'!
createExampleTestResult
	| aTestResult |
	aTestResult := STestResult new.
	aTestResult addToPassed: (STbPersonTest selector: #testFirstnameAccessors).
	^ aTestResult.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.473'!
ensureCoverageOfExampleCode
	self runAndTraceSuite: STbPersonTest suite. ! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.465'!
testNonInstrumentation
	| aSubclass aSelector |
	
	self runAndTraceSuite: STbPersonTest suite.
	self should: [ (STbPerson >> #firstname) isMwMethodWrapper ].
	
	self codeSight turnOffStandaloneMode.
	self shouldnt: [ (STbPerson >> #firstname) isMwMethodWrapper ].
	
	self undoInTearDownDo: [
		aSubclass := self createExamplePersonSubclass.
		aSelector := aSubclass compile: self exampleMethodSource ].
	
	self shouldnt: [ (aSubclass >> aSelector) isMwMethodWrapper ].! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 17:53:37.472'!
testOpenEvents
	self ensureCoverageOfExampleCode.
	self codeSight makeDistributed.
	self should: [ self codeSight openEvents isEmpty ].
	
	self compileExampleMethod.
	self shouldnt: [ self codeSight openEvents isEmpty ]! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 08:57:10.433'!
testProcessingOfUpdates
	| aTestResult testsToCoverageData |
	self ensureCoverageOfExampleCode.
	self exampleMethod fixes: self exampleTestMethod.
	self codeSight makeDistributed.
	
	aTestResult := self createExampleTestResult.
	testsToCoverageData := self createExampleCoverageData.
	
	self csTestRunner reset.
	self compileExampleMethod.
	self should: [ self csTestRunner result passed isEmpty ].
	self shouldnt: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod hasFixedTestMethods ].
	
	self codeSight testResult: aTestResult.	
	self codeSight testCoverage: testsToCoverageData.
	self shouldnt: [ self csTestRunner result passed isEmpty ]. 
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].
	
	self csTestRunner reset.
	self compileExampleMethod.
	self codeSight testCoverage: testsToCoverageData.
	self codeSight testResult: aTestResult.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].! !

SAutoTddTestBase subclass: #SEvolutionTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

SEvolutionTestCase subclass: #SFixedTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 12/9/2009 16:57'!
charIntervalIn: codeString fromLine: from toLine: to
	| start end |
	self assert: [ codeString lineCount >= to and: [ codeString lineCount >= from ] ].
	start := 1.
	(1 to: (from - 1)) do: [:lineNo | 
		start := start + (codeString lineNumber: lineNo) size ].
	
	end := start.
	(to to: codeString lineCount) do: [:lineNo |
		end := end + (codeString lineNumber: lineNo) size ].
	
	^ (start to: end)! !

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.51'!
testEstablishingFixedRelationship
	
	self undoInTearDownDo: [
		self removeMethod: self exampleMethod ].
	 
	STbPersonTest compile: self exampleTestMethodSource.
	STbPerson compile: self exampleMethodSource. 
	
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].
	! !

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 19:57'!
testRecompiling

	self runExampleTests.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	(self exampleMethod) fixes: self exampleTestMethod.
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	self compileExampleMethod.
	self should: [ self exampleMethod hasCoveringTestMethods ]. 
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].! !

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.957'!
testRefactoringVariations
	| code anExamplePerson variationWrapper selectionInterval |
	
	code := (STbPerson sourceCodeAt: #firstname) asString.
	selectionInterval := self charIntervalIn: code fromLine: 2 toLine: 2.
	self assert: [ code lineCount = 2 ].
	
	anExamplePerson := STbPerson new.
	anExamplePerson firstname: 'Paul'.
	self should: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper := SRefactoringVariationWrapper 
							on: #firstname 
							inClass: STbPerson 
							withCode: 'firstname'.
	
	variationWrapper installClosestToMethod.
	self deny: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper uninstall.! !

SEvolutionTestCase subclass: #STddMonitoringTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!STddMonitoringTests methodsFor: 'running' stamp: 'bs 1/8/2010 18:48'!
setUp
	super setUp.
	
	self undoInTearDownDo: [
		self removeMethod: self exampleMethod. 
		self removeMethod: self exampleTestMethod ].! !

!STddMonitoringTests methodsFor: 'accessing' stamp: 'bs 1/8/2010 17:39'!
tddMonitor
	^ self csTestRunner tddMonitor! !

!STddMonitoringTests methodsFor: 'tests' stamp: 'bs 7/12/2010 20:27:50.659'!
testDeletionOfTests
	self undoInTearDownDo: [
		self installMethod: 'testFail1 self fail' inClass: STbPersonTest. 
		self installMethod: 'testFail2 self fail' inClass: STbPersonTest. ].
	
	self should: [ self tddMonitor list activities size = 2 ].
	self should: [ (self tddMonitor list activities reject: [ :ea | ea isFinished ]) size = 2 ].
	
	STbPersonTest removeSelector: #testFail1.
	self should: [ self tddMonitor list activities size = 1 ].! !

!STddMonitoringTests methodsFor: 'tests' stamp: 'bs 6/30/2010 12:04:53.886'!
testRefactoringBehavior
	| activity |
	self 
		compileExampleTestMethod;
		compileExampleMethod;
		should: [ self tddMonitor list activatedActivity isNil ].
		
	self removeMethod: self exampleMethod.
	activity := self tddMonitor list activatedActivity.  
	self should: [ activity notNil ].
	self should: [ activity isRefactoring ].
	self should: [ activity brokenTests include: self exampleTestMethod ].
	self should: [ activity previouslyFixedTests includes: self exampleTestMethod ].
	self should: [ (activity methodsThatPreviouslyFixedTest: self exampleTestMethod) isEmpty ].
	
	"eigentlich - make test fail by insert self fail in first line
	 now we are in refactoring mode
	 if test is fixed, the example method should be linked in the fixed relationship, aber nur, wenn weiterhin gecovered"! !

!STddMonitoringTests methodsFor: 'tests' stamp: 'bs 7/12/2010 20:27:50.667'!
testSpecifyingUnsupportedTest
	| activity |
	STbPersonTest compile: self exampleTestMethodSource.
	activity := self tddMonitor list activatedActivity. 
	self assert: [ activity notNil ].
	self assert: [ activity isNewBehavior and: [ activity testMethod = self exampleTestMethod ]  ].! !

!STddMonitoringTests methodsFor: 'tests' stamp: 'bs 7/12/2010 20:27:50.674'!
testTestGetsBeingSupported
	| activity |
	STbPersonTest compile: self exampleTestMethodSource.
	activity := self tddMonitor list activatedActivity. 
	self shouldnt: [ activity isFinished ].
	self should: [ activity addedOrModifiedMethods isEmpty ].
	
	STbPerson compile: self exampleMethodSource. 
	self should: [ activity isFinished ].
	self should: [ activity addedOrModifiedMethods includes: self exampleMethod ].! !

!STddMonitoringTests methodsFor: 'tests' stamp: 'bs 1/4/2010 10:45'!
testToDos
	
	"was passiert, wenn ich eine methode ndere und dabei ein test wieder rot wird."! !

SAutoTddTestBase subclass: #SFailedExpressionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.504'!
failingTestMethod
	^ STbPersonTest >> #testFailing! !

!SFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.496'!
testRecordingOfFailedExpression
	| source class selector |
	class := STbPersonTest. 
	source := 'testRecordingOfFailedExpression', String cr,  'self notExistingMethod'.
	self undoInTearDownDo: [
		selector := self installMethod: source inClass: STbPersonTest ].
	
	self assert: [ (class >> selector) failedExpressionInterval notNil ].
	self assert: [ (class >> selector) failedExpression = 'notExistingMethod' ].
	
	STbPersonTest compile: 'testRecordingOfFailedExpression', String cr.
	self assert: [ (class >> selector) failedExpressionInterval isNil ].! !

SAutoTddTestBase subclass: #SFixturesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/27/2009 14:28'!
testAdditionOfOverridingMethod
"	| personsubclass selector method superCallTestSelector superCallTestMethod |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	superCallTestMethod := (CSExampleTest >> superCallTestSelector).
	superCallTestMethod called: method receiver: nil.
	method fixes: superCallTestMethod.
	self should: [ method hasFixedTestMethods ].
		
	personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
	self shouldnt: [ testRunner result passed size = 0 ].
	self should: [ (personsubclass >> selector) hasCoveringTestMethods  ].
	self should: [ (personsubclass >> selector) hasFixedTestMethods  ]."! !

!SFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/30/2009 21:44'!
testFixedTestMethods
"	| testMethod appMethod |
	appMethod := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	
	appMethod fixes: testMethod. 
	self should: [ appMethod fixedTestMethods size = 1 ].
	appMethod resetFixedTestMethods.	
	self should: [ appMethod fixedTestMethods size = 0 ]."! !

!SFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/30/2009 21:44'!
testFixesInDoForEachBlock
"	| testMethod appMethod |
	appMethod := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	appMethod resetAllCoverageData.
	testMethod resetAllCoverageData.
	
	testMethod doForEachCoveredMethod: [:blockTestMethod :blockAppMethod |
		blockAppMethod fixes: blockTestMethod ].
	
	testMethod called: appMethod receiver: nil.
	self should: [ appMethod coveringTestMethods size = 1 ].
	self should: [ appMethod fixedTestMethods size = 1 ].
	
	appMethod resetAllCoverageData.
	testMethod resetAllCoverageData."! !

!SFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/30/2009 21:43'!
testRecompiling
"	| testMethod |
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	
	(CSExamplePerson >> #firstname) fixes: testMethod.
	self should: [ (CSExamplePerson >> #firstname) fixedTestMethods size = 1 ].
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname).
	self should: [ (CSExamplePerson >> #firstname) fixedTestMethods size = 1 ]."! !

!SFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/27/2009 14:26'!
testRefactoring
"	| personsubclass selector method superCallTestSelector subMethod |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	testRunner reset.
	personsubclass compile: selector asString.
	self should: [ testRunner result passed size = 1 ].
	
	subMethod := (personsubclass >> selector) clientMethod.
	self should: [ subMethod hasCoveringTestMethods ].
	subMethod fixes: (CSExampleTest >> superCallTestSelector).
	self should: [ subMethod hasFixedTestMethods ].
	
	testRunner reset.
	personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
	self should: [ testRunner result passed size = 1 ].
	self should: [ (CSExamplePerson >> selector) hasCoveringTestMethods ].
	self should: [ (CSExamplePerson >> selector) hasFixedTestMethods ].
	
	testRunner reset.
	personsubclass compile: selector asString.
	self should: [ testRunner result passed size = 1 ].
	self shouldnt: [ (CSExamplePerson >> selector) hasFixedTestMethods ]."! !

!SFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/27/2009 14:27'!
testRemoveOfOverriddenMethod
"	| personsubclass selector method superCallTestSelector |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	method fixes: (CSExampleTest >> superCallTestSelector).
		
	self undoInTearDownDo: [
		self removeMethod: method inClass: CSExamplePerson].	
	
	self should: [ (personsubclass >> selector) hasFixedTestMethods ]"! !

SAutoTddTestBase subclass: #STddAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!STddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:32:16.839'!
createFooBarTestClass
	| aClass |
	aClass := TestCase subclass: #STbFooBarTest
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: self tbCategory.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass.! !

!STddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:34:45.551'!
createSubclassTestCode
	^ 'testFirstnameAccessorsForPersonAndAllSubclasses
			| aPerson aName |
			STbPerson withAllSubclassesDo: [:aPersonClass | 
			aPerson := aPersonClass new.
			aName := #Bastian asString.
			aPerson firstname: aName.
			self assert: aPerson firstname = aName. ]'! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.556'!
testAddAndChangeOfNonTestMethodsInTestClasses
	| selector |
	[	selector := #setUp.
		STbPersonTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty].
		STbPersonTest compile: selector, String crlf.
		STbPersonTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty]]
	ensure: [
		(STbPersonTest includesSelector: selector) 
			ifTrue: [STbPersonTest removeSelector: selector]].
	! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.625'!
testAdditionAndRemovalOfOverriddenMethod
	| methodSelector testMethodSelector methodSource personsubclass |
	
	methodSelector := #asString.
	methodSource := (STbPerson >> methodSelector) clientMethod getSource.

	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: methodSource.
		testMethodSelector := self installMethod: self createSuperCallTestCode inClass: STbPersonTest ].
	
	self runAndTraceInSuite: (STbPersonTest >> testMethodSelector).
	self shouldnt: [ (STbPerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	self undoInTearDownDo: [
		self removeMethod: (STbPerson >> methodSelector) ].
		
	self should: [ self csTestRunner result passed size = 1 ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	STbPerson compile: methodSource.
	self should: [ self csTestRunner result passed size = 1].
	self shouldnt: [ (STbPerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.58'!
testAdditionAndRemovalOfSubclassesWithOverridingMethods
	| selector source subclass |
	STbPerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	selector := #firstname.
	source := STbPerson sourceCodeAt: selector.
	
	self undoInTearDownDo: [
		subclass := self createExamplePersonSubclass.
		self installMethod: self createSubclassTestCode inClass: STbPersonTest ].
	
	self runAndTraceSuite: STbPersonTest suite.
	self should: [ self csTestRunner result passed size = 2 ].
	self should: [ (STbPerson >> #firstname) coveringTestMethods size = 2 ].
	
	self csTestRunner reset.
	subclass compile: source.
	self should: [ self csTestRunner result passed size = 2 ].
	
	self csTestRunner reset.
	subclass removeSelector: selector.
	self should: [ self csTestRunner result passed size = 1 ].
	
	subclass compile: source.
	self csTestRunner reset.
	subclass removeFromSystem.
	self should: [ self csTestRunner result passed size = 1 ].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.545'!
testDistinguishingOfTestsHavingEqualHashes
	| failingCode1 failingMethod1 failingCode2 failingMethod2 |

	"test adding"
	self undoInTearDownDo: [
		failingCode1 := 'testFailingTest1 self fail'.
		failingCode2 := 'testFailingTest2 self fail'.
		failingMethod1 := self installMethod: failingCode1 inClass: STbPersonTest.
		failingMethod2 := self installMethod: failingCode2 inClass: STbPersonTest. ].
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod1 ] ] ].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod2 ] ] ].

	"test modification"
	self installMethod: failingCode1 inClass: STbPersonTest.
	self installMethod: failingCode2 inClass: STbPersonTest.
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod1 ] ] ].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod2 ] ] ].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.607'!
testDontResetResultIfThereIsNothingToRun
	|source|
	self csTestRunner runSuite: STbPersonTest suite.
	self shouldnt: [self csTestRunner result passed = 0].
	
	source := ('fooBar', String crlf).
	self undoInTearDownDo: [
		self installMethod: source inClass: STbPerson.].
	self shouldnt: [self csTestRunner result passed = 0].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.572'!
testExecutionOfAddedTestMethod
	| source runTestCase aMethod |
	aMethod := STbPersonTest >> #testFirstnameAccessors.
	source := aMethod getSource.
	
	self undoInTearDownDo: [
		self removeMethod: aMethod ].
	STbPersonTest compile: source.
	
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: STbPersonTest].
	self should: [runTestCase selector = aMethod selector].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.591'!
testExecutionOfCoveringTestsAfterMethodChanged

	self undoInTearDownDo: [
		self tracePackage: self tbPackage ].
	self runAndTraceSuite: STbPersonTest suite. 
	
	STbPerson compile: (STbPerson sourceCodeAt: #firstname:).
	self should: [self csTestRunner result passed isEmpty not]. 
	self should: [self csTestRunner result passed first isKindOf: STbPersonTest].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.615'!
testExecutionOfFailedTestsAfterMethodAddedOrChanged
	| methodSelector appMethodSource method | 
	methodSelector := #firstname.
	appMethodSource := STbPerson sourceCodeAt: methodSelector.
	method := STbPerson >> methodSelector.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		self removeMethod: method].
	
	self runAndTraceSuite: STbPersonTest suite.
	self deny: [self csTestRunner result errors isEmpty].
	self should: [self csTestRunner result errors anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = #testFirstnameAccessors]]].
	
	STbPerson compile: appMethodSource.
	self should: [self csTestRunner result errors isEmpty].
	self deny: [self csTestRunner result passed isEmpty].
	self should: [self csTestRunner result passed first isKindOf: STbPersonTest].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.534'!
testExecutionOfFailedTestsAfterTestChanged
	| aSuite failingCode failingMethod2 |
	aSuite := TestSuite new.
	aSuite addTest: (STbPersonTest >> #testFailing) newTestCase.
	self csTestRunner runSuite: aSuite.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = #testFailing]]].

	self undoInTearDownDo: [
		failingCode := 'testFailing2 self fail'.
		failingMethod2 := self installMethod: failingCode inClass: STbPersonTest ].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = #testFailing]]].

	STbPersonTest compile: failingCode.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = #testFailing]]].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod2]]].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/11/2010 07:41'!
testForEndlessLoopUsingDoForEachCoveredMethod

	"self csTestRunner testCasesToRun add: (CSExampleTest selector: #testFirstnameAccessors).
	self csTestRunner runOpenTestCasesInSuite."
	
	"original version that break a lot of stuff.
	 I assume that using 'self doForEachCoveredMethod' in another doForEach.. Block was not a good idea"
	"CSTestRunner >> #runOpenTestCasesInSuite
	| aSuite testMethod |
	
	aSuite := TestSuite new.
	
	self failedTestCases do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			anAppMethod fixes: aTestMethod.
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}] ].
	
	
	self testCasesToRun do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}]].
	
	self resetTestCasesToRun.
	
	aSuite tests ifNotEmpty: [
		self reset; runSuite: aSuite].
	
	self doForEachCoveredMethod: nil."
	! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 7/12/2010 20:27:50.525'!
testModificationOfClass
	| instVarName classVarName |
	instVarName := 'foobar'. 
	classVarName := 'Foobar'.
	[	self instrumentor instrumentClass: STbPerson.
		self runAndTraceSuite: STbPersonTest suite.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods].

		STbPerson addInstVarName: instVarName.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods].
		
		STbPerson addClassVarName: classVarName.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods] ]
	ensure: [
		(STbPerson instVarNames includes: instVarName)
			ifTrue: [STbPerson removeInstVarName: instVarName].
		(STbPerson classVarNames includes: classVarName)
			ifTrue: [STbPerson removeClassVarName: classVarName].
		self instrumentor uninstrumentClass: STbPerson]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 7/12/2010 20:27:50.599'!
testModificationTestOfClass
	|instVarName|
	instVarName := 'foobar'.
	[	self instrumentor instrumentClass: STbPerson.
		STbPersonTest addInstVarName: instVarName.
		self should: [self csTestRunner result passed size = 1].
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods]]
	ensure: [
		(STbPersonTest instVarNames includes: instVarName)
			ifTrue: [STbPersonTest removeInstVarName: instVarName].
		self instrumentor uninstrumentClass: STbPerson]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 11:10'!
testRemovalOfFailedTestCase
	| selector testClass |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	selector := #testFooBar.
	self installMethod:  selector, String crlf, String tab, 'self fail.' inClass: testClass.
	
	self should: [self csTestRunner result failures notEmpty].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: testClass) and: [test selector = selector]]].
	
	testClass removeSelector: selector.
	self should: [self csTestRunner result failures isEmpty].
	self should: [self csTestRunner result errors isEmpty]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 4/23/2010 09:19:00.846'!
testRemovalOfFailedTestsAfterTestClassOrMethodRemoved
	| testClass fooBarSource testMethodSelector |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	fooBarSource := 'testFooBar', String crlf , String tab , 'self fail'.
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeSelector: testMethodSelector.
	self should: [ self csTestRunner result failures isEmpty ].
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeFromSystem.
	self should: [ self csTestRunner result failures isEmpty ].! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 1/8/2010 17:31'!
testRemovalOfTestClass
	|testClass testClassName|
	[	testClass := self createFooBarTestClass. 
		testClassName := testClass name.
		testClass compile: 'testFooBar', String crlf, String tab, 'self fail'.
		self should: [self csTestRunner result failures size = 1].
		testClass removeFromSystem.
		self should: [self csTestRunner result failures isEmpty]]
	ensure: [
		(Smalltalk classNamed: testClassName) 
			ifNotNil: [testClass removeFromSystem]]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 7/12/2010 20:27:50.564'!
testRenamingOfClass
	|class oldName|
	[
		self runAndTraceSuite: STbPersonTest suite. 
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods].
		
		class := STbPerson.
		oldName := class name.
		STbPerson rename: (oldName, 'new').
		self should: [(class >> #firstname) hasCoveringTestMethods].]
	ensure: [
		class rename: oldName.
		self instrumentor uninstrumentClass: STbPerson]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.518'!
testRepro
	| aSuite |
	STbPerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	
	aSuite := TestSuite new.
	aSuite addTest: (STbPersonTest selector: #testFirstnameAccessors).
	self csTestRunner runSuite: aSuite.
	self should: [ self csTestRunner result passed size = 1 ]! !

STddAutoRunTests subclass: #STestModificationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.682'!
testAddingTestMethod
	| source runTestCase aMethod |
	aMethod := STbPersonTest >> #testFirstnameAccessors.
	source := aMethod getSource.
	
	self undoInTearDownDo: [
		self removeMethod: aMethod ].
	STbPersonTest compile: source.
	
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: STbPersonTest].
	self should: [runTestCase selector = aMethod selector].! !

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 12:17:29.194'!
testModifyingTestMethod
	| exampleTestMethodVersion1 coveringTestMethods |
	self should: [self csTestRunner result passed isEmpty].
	
	self compileExampleTestMethod.
	self shouldnt: [self csTestRunner result passed isEmpty].
	
	exampleTestMethodVersion1 := self exampleTestMethod.
	self compileExampleTestMethod.
	coveringTestMethods := self exampleMethod coveringTestMethods.
	self should: [coveringTestMethods includes: self exampleTestMethod].
	self shouldnt: [coveringTestMethods includes: exampleTestMethodVersion1].! !

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 12:16:24.049'!
testRemovingTestClassOrMethod
	| testClass testMethodSelector |
	
	self should: [self exampleMethod coveringTestMethods size = 0].
	
	self undoInTearDownDo: [ testClass := self createFooBarTestClass ].
	testMethodSelector := testClass compile: self exampleTestMethodSource.
	
	self should: [self csTestRunner result passed size = 1].
	self should: [self exampleMethod coveringTestMethods size = 1].
	
	testClass removeSelector: testMethodSelector.
	self should: [self exampleMethod coveringTestMethods size = 0].
	
	testClass compile: self exampleTestMethodSource.
	testClass removeFromSystem.
	
	self should: [self exampleMethod coveringTestMethods size = 0].
	! !

SCTestBase subclass: #SBasicTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SBasicTests methodsFor: 'running' stamp: 'bs 1/23/2010 14:33'!
setUp
	super setUp.
	self codeSight activateTracing.! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.403'!
testConcreteClassCoverage
	self deny: self exampleMethod hasMethodExtension.
	
	self tracePackage: self tbPackage.
	self runAndTraceSuite: (STbPersonTest suite).
	
	self assert: [ self exampleMethod hasCoveringTestMethods ].
	self deny: [ (self exampleMethod coveringTestMethodsWhenReceiverWasOfKind: STbPerson) size = 0 ].! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:02:10.642'!
testCoverageApi
	| testMethod method |
	method := (STbPerson >> #firstname) clientMethod.
	testMethod := (STbPersonTest >> #testFirstnameAccessors) clientMethod.
	method 
		resetAllCoverageData;
		methodExtension: SNonTestMethodExtension new.
	method cstMethodExtension clientMethod: method.
		
	testMethod 
		resetAllCoverageData;
		methodExtension: STestMethodExtension new.
	testMethod cstMethodExtension clientMethod: testMethod.
	
	testMethod called: method receiver: nil.
	
	self should: [method hasCoveringTestMethods].
	self shouldnt: [testMethod hasCoveringTestMethods].
	self should: [method coveringTestMethods size = 1].
	self should: [method fixedTestMethods size = 0].
	self should: [method coveringAndNotFixedTestMethods size = 1].
	self should: [testMethod coveredMethods includes: method].
	self should: [testMethod coveredMethodsStatistics isEmpty not].
	
	method 
		resetAllCoverageData;
	 	resetMethodExtension.
	testMethod 
		resetAllCoverageData;
		resetMethodExtension.! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.389'!
testRetrievingTestsForMethod
	| aSuite |
	self tracePackage: self tbPackage.
	aSuite := STbPersonTest suite.
	self runAndTraceSuite: aSuite.
	self assert: (self exampleMethod coveringTestMethods includes: STbPersonTest >> #testFirstnameAccessors).! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.396'!
testRetrievingTestsForQuickReturnMethod
	| aSuite |
	self tracePackage: self tbPackage.
	aSuite := STbPersonTest suite.
	self runAndTraceSuite: aSuite.
	self assert: ((STbPerson>>#firstname) coveringTestMethods includes: STbPersonTest >> #testFirstnameAccessors).! !

!SCTestBase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight
	^ codeSight! !

!SCTestBase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight: anObject
	codeSight := anObject! !

!SCTestBase methodsFor: 'running' stamp: 'bs 7/4/2010 12:48:15.208'!
codeSightClass
	^ SCodeSight! !

!SCTestBase methodsFor: 'running' stamp: 'bs 7/5/2010 10:34:10.059'!
createInstrumentor
	^ SInstrumentor wrapping! !

!SCTestBase methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ self codeSight csTestRunner! !

!SCTestBase methodsFor: 'accessing' stamp: 'bs 1/4/2010 15:40'!
instrumentor
	^ self codeSight instrumentor! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 13:40:38.561'!
registerPackage: aPackageInfo
	self codeSight addToManagedPackages: aPackageInfo.! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:02'!
registeredPackages
	^ registeredPackages ifNil: [registeredPackages := OrderedCollection new]! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/4/2010 12:01'!
reregisterPackages
	self unregisteredPackages copy do: [:aPackageInfo |
		self instrumentor instrumentPackage: aPackageInfo.
		self unregisteredPackages remove: aPackageInfo ].! !

!SCTestBase methodsFor: 'running' stamp: 'bs 7/12/2010 20:23:54.506'!
resetTbPackage
	self tbClasses do: [ :aClass | 
		aClass methodDict values do: [ :method | method resetMethodExtension ] ].! !

!SCTestBase methodsFor: 'running' stamp: 'bs 3/2/2010 09:32:31.905'!
runAndTraceInSuite: aTestMethod
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: aTestMethod newTestCase.
	self runAndTraceSuite: aSuite.! !

!SCTestBase methodsFor: 'running' stamp: 'bs 1/22/2010 10:24'!
runAndTraceSuite: aSuite
	self codeSight activateTracing.
	self csTestRunner reset; runSuite: aSuite.
	self codeSight deactivateTracing.! !

!SCTestBase methodsFor: 'accessing' stamp: 'bs 7/12/2010 20:27:50.445'!
runExampleTests
	self runAndTraceSuite: STbPersonTest suite.! !

!SCTestBase methodsFor: 'running' stamp: 'bs 7/12/2010 20:24:16.908'!
setUp
	super setUp.
	self resetTbPackage.
	
	self codeSight: self codeSightClass new.
	
	tddAutoRunTestRunner := STestRunner 
		allSubInstances select: [:runner | runner isInTddAutoRunMode].
	tddAutoRunTestRunner do: [:runner | runner tddAutoRunStop].
! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'replica 5/20/2010 22:56:10.258'!
stopTracingPackage: aPackageInfo
	self unregisterPackage:  aPackageInfo! !

!SCTestBase methodsFor: 'running' stamp: 'bs 7/12/2010 20:24:05.377'!
tearDown
	self
		unregisterPackages;
		reregisterPackages.

	self codeSight cleanUp.
	self codeSight: nil.
	self resetTbPackage.
		
	tddAutoRunTestRunner do: [:runner | runner tddAutoRunStart].
	
	super tearDown.! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 12:32:03.746'!
tracePackage: aPackageInfo
	(self codeSight managedPackages includes: aPackageInfo)
		ifFalse: [ self registerPackage: aPackageInfo ]! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 07:49:28.968'!
unregisterPackage: aPackageInfo
	self codeSight removeFromManagedPackages: aPackageInfo. ! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 13:41:00.643'!
unregisterPackages
	self codeSight managedPackages copy do: [:aPackageInfo |
		self codeSight removeFromManagedPackages: aPackageInfo ]. ! !

!SCTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:20'!
unregisteredPackages
	^ unregisteredPackages ifNil: [unregisteredPackages := OrderedCollection new]! !

SCTestBase subclass: #SClassEventTests
	instanceVariableNames: 'unwrappedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/15/2010 15:05'!
handleClassEvent: aClassEvent
	unwrappedMethods := aClassEvent oldItem methodDict values collect: [ :ea | ea unwrappedMethod ]! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:26:07.811'!
setUp
	super setUp.
	self undoInTearDownDo: [
		self tracePackage: self tbPackage ].! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/11/2010 10:18'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.897'!
tearDown
	self systemNotifier noMoreNotificationsFor: self.
	Object subclass: #STbPerson
		instanceVariableNames: 'firstname'
		classVariableNames: ''
		poolDictionaries: ''
		category: self tbCategory.
	super tearDown.! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.89'!
testMethodDictAccessOfModifiedClass
	self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	Object subclass: #STbPerson
		instanceVariableNames: 'firstname f'
		classVariableNames: 'Foo'
		poolDictionaries: ''
		category: self tbCategory.
	self shouldnt: [ unwrappedMethods anySatisfy: [ :ea | ea == nil ]  ].! !

SCTestBase subclass: #SCodeSightTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SCodeSightTests methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 17:28'!
testOpenCloseTestRunner
	| aTestRunnerMorph |
	aTestRunnerMorph := self csTestRunner open.
	self should: [ aTestRunnerMorph isKindOf: SystemWindow ].
	aTestRunnerMorph delete.! !

Object subclass: #ATddBenchmarker
	instanceVariableNames: 'packages methods coveredMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 03:51'!
appMethods

	| class |
	^ self methods reject: [:ea |
		class := ea methodClass ifNil: [ea clientMethod searchForClass].
		class
			ifNil: [false]
			ifNotNil: [class inheritsFrom: TestCase]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/20/2009 03:38'!
classesOfPackages

	^ (packages gather: [:p | p classes]) asSet! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestClassesTimesPerMethodFrom: timeForEachTestClass

	| testClassesTimesPerMethod |
	testClassesTimesPerMethod := Dictionary new. "appMethod -> coveringTestClassesTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testClassesTimesPerMethod
			at: appMethod
			put: (self coveringTestClassesTimeFor: appMethod from: timeForEachTestClass)].
	^ testClassesTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestTimesPerMethodFrom: timeForEachTest

	| testTimesPerMethod |
	testTimesPerMethod := Dictionary new. "appMethod -> coveringTestMethodsTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testTimesPerMethod
			at: appMethod
			put: (self coveringTestMethodsTimeFor: appMethod from: timeForEachTest)].
	^ testTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 03:48'!
computeTimeForAllTestsFrom: timeForEachTest

	^ timeForEachTest values sum.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'bs 7/4/2010 12:48:52.392'!
computeTimeForEachTest

	| aTestRunner testClasses timeForEach |
	aTestRunner := STestRunner new.
	testClasses := self testClassesOfPackages.
	timeForEach := Dictionary new.
	testClasses
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | | time |
					time := [aTestRunner runSuite: (testClass suiteWithSelectorsMatching: s)] timeToRun.
					timeForEach at: (testClass >> s) methodReference put: time]]
		displayingProgress: 'Running Tests (' , testClasses size asString, ' test classes)'.
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 18:11'!
computeTimeForEachTestClassFrom: timeForEachTest

	| timeForEach |
	timeForEach := Dictionary new.
	self testClassesOfPackages do: [:class | | methodsOfClass time |
		methodsOfClass := timeForEachTest keys select: [:m | m actualClass = class].
		time := methodsOfClass inject: 0 into: [:t :m | (timeForEachTest at: m) + t].
		timeForEach at: class put: time].
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestClassesTimeFor: appMethod from: timeForEachTestClass

	| testClasses |
	testClasses := (appMethod coveringTestMethods
		collect: [:ea | ea methodClass]
		thenSelect: [:ea | ea isObsolete not]) asSet.
	^ testClasses
		inject: 0
		into: [:sum :c | (timeForEachTestClass at: c) + sum].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestMethodsTimeFor: appMethod from: timeForEachTest

	^ appMethod coveringTestMethods
		inject: 0
		into: [:sum :m | (timeForEachTest at: m methodReference ifAbsent: [0"???"]) + sum].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'rkrk 9/20/2009 18:17'!
measureCoveringTimesForPackages: packageString

	^ String streamContents: [:stream |
		self 
			measureCoveringTimesForPackages: packageString 
			printOn: stream].
	! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 7/4/2010 12:47:14.296'!
measureCoveringTimesForPackages: packageString printOn: stream

	"^ #(coveringTestMethodsTime coveringTestClassesTime timeForRunningAllTestsAtEveryChange)"
	| timeForEachTest timeForEachTestClass timeForAllTests testClassesTimesPerMethod testTimesPerMethod coveredTestMethodsTimes coveredTestClassesTimes |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	packages do: [:p | SWrappingInstrumentor systemInstrumentor instrumentPackage: p].

	timeForEachTest := self computeTimeForEachTest.
	timeForEachTestClass := self computeTimeForEachTestClassFrom: timeForEachTest.
	timeForAllTests := self computeTimeForAllTestsFrom: timeForEachTest.
	testTimesPerMethod := self computeTestTimesPerMethodFrom: timeForEachTest.
	testClassesTimesPerMethod := self computeTestClassesTimesPerMethodFrom: timeForEachTestClass.

	"CSV style output
	appMethods,coveredMethods,coveredTestMethodsTimes average, coveredTestMethodsTimes median, coveredTestMethodsTimes min, coveredTestMethodsTimes max, coveredTestMethodsTimes sum, coveredTestClassesTimes avg, coveredTestClassesTimes median, coveredTestClassesTimes sum, timeForAllTests, timeForAllTests sum"
	coveredTestMethodsTimes := testTimesPerMethod values.
	coveredTestClassesTimes := testClassesTimesPerMethod values.
	stream
		print: self appMethods size; nextPut: $,;
		print: (self methodsCovered: self appMethods) size; nextPut: $,;
		print: (coveredTestMethodsTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestMethodsTimes median roundTo: 1); nextPut: $,;
		print: coveredTestMethodsTimes min; nextPut: $,;
		print: coveredTestMethodsTimes max; nextPut: $,;
		print: coveredTestMethodsTimes sum; nextPut: $,;
		print: (coveredTestClassesTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestClassesTimes median roundTo: 1); nextPut: $,;
		print: coveredTestClassesTimes sum; nextPut: $,;
		print: timeForAllTests; nextPut: $,;
		print: (self methodsCovered: self methods) size * timeForAllTests;
		cr.
		
	packages do: [:p |SInstrumentor systemInstrumentor uninstrumentPackage: p].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 7/4/2010 12:48:52.401'!
measureTestExecutionTimeForPackages: packageString

	| aTestSuite testClasses nRuns |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	"packages do: [:p | CSCoverageTracingWrapper registerPackage: p]."
	
	aTestSuite := TestSuite new.
	testClasses := self testClassesOfPackages.
	
	self testClassesOfPackages
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | aTestSuite addTest: (testClass selector: s)]].
			
	nRuns := 2.
	^ ([nRuns timesRepeat: [STestRunner new runSuite: aTestSuite]] timeToRun / nRuns).
	! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
methods

	^ methods ifNil: [
		methods := self classesOfPackages gather: [:class |
			class methodDict values]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 04:16'!
methodsCovered: methodCol

	^ methodCol select: [:ea | ea hasCoveringTestMethods].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
testClassesOfPackages

	^ self classesOfPackages select: [:class |
		class inheritsFrom: TestCase].! !

Object subclass: #ATddMCAnalyzer
	instanceVariableNames: 'inspector methodVersionResult doAfterGathering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'bs 11/20/2009 15:42'!
printVersionDatesOfPackage: packageName

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: packageName
		thenDo: [:versionInfos |
			self halt.
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'rkrk 9/20/2009 00:57'!
printVersionDatesOfPackage: packageName inRepo: repo

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: {packageName}
		in: repo
		thenDo: [:versionInfos |
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.794'!
gatherVersionsOf: packageNames in: mcRepository thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld 
		newForPackagesNamed: packageNames
		inRepo: mcRepository.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.787'!
gatherVersionsOf: packageName thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.779'!
inspect: selector of: class in: packageName 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector 
		startInspectVersionsFor: selector
		in: class.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'nil' stamp: 'rkrk 9/20/2009 00:58'!
methodVersionResult

	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 00:24'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifFalse: [^ self].
	Transcript cr show: 'done'.
	doAfterGathering value: methodVersionResult.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2009 23:13'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #versionFound ifFalse: [^self].
	Transcript cr; show: 'Found ' , anObject asString.
	methodVersionResult add: anObject.! !

Object subclass: #ATddReceiverAnalyzer
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
getClassOf: method

	^ method methodClass ifNil: [method searchForClass].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:38'!
init

	stream := WriteStream on: ''.! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:29'!
isOverwritten: method

	"CompiledMethod>>overridingMethods does not work"
	^ (self overridingClasses: method) notEmpty! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:35'!
methodsNotOverwrittenIn: package

	^ ((package coreMethods collect: [:ea | ea compiledMethod]
		thenSelect: [:method | method hasCoveringTestMethods])
		reject: [:method | self isOverwritten: method])
		reject: [:method | (self getClassOf: method) allSubclasses isEmpty].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
overridingClasses: method

	^ (self getClassOf: method) allSubclasses select: [:ea |
		ea includesSelector: method selector].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 22:29'!
printTestsForOverwrittenMethodsWithAndWithoutReceiverIn: package

	"self printTestsForOverwrittenMethodsWithAndWithoutReceiverIn:
		(PackageInfo named: 'AweSOM')"
	| methods
	appMethodClass pureTestCount testCountReceiver allNoRecv allRecv stat |
	self init.
	methods := self methodsNotOverwrittenIn: package.
	methods do: [:appMethod |
		appMethodClass := self getClassOf: appMethod.
		pureTestCount := appMethod coveringTestMethods size.
		allNoRecv := allRecv := 0.
		"<for each subclass>"
		appMethodClass allSubclasses do: [:subclass |
			testCountReceiver := 0.
			"<for each coveringTest>"
			"<if subclass or any of its subclasses are
			included in receiverclasses of coveringTest --> count+1>"
			testCountReceiver := appMethod coveringTestMethods count: [:test | 
				stat := test statisticsForCoveredMethod: appMethod clientMethod.
				(stat receiverClasses includesAnyOf: subclass withAllSubclasses)].
			"----"
			allNoRecv := allNoRecv + pureTestCount.
			allRecv := allRecv + testCountReceiver.
			"print it"
			stream
				cr; nextPutAll: 'If method '; nextPutAll: appMethod selector;
				nextPutAll: ' would be added to '; nextPutAll: subclass name; space;
				print: pureTestCount; nextPutAll: '/'; print: testCountReceiver;
				nextPutAll: ' should run.'.
		].
		"print it again"
		stream
			cr; print: allRecv; nextPut: $/; print: allNoRecv;
			nextPut: $=;
			print: (allRecv isZero
				ifTrue: [0]
				ifFalse: [allRecv / allNoRecv * 100 asFloat]).
		Transcript show: stream contents.
	].! !

Object subclass: #ATddVersionLoader
	instanceVariableNames: 'repo versionFileNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!ATddVersionLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
loadVersionsNamed: versionNames from: mcRepository

	| fileNames |
	fileNames := versionNames collect: [:ea |
		(ea endsWith: '.mcz') ifTrue: [ea] ifFalse: [ea , '.mcz']].
	self new
		repo: mcRepository;
		versionFileNames: fileNames;
		loadAll;
		yourself.! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:46'!
loadAll

	| versions |
	versions := self versionFileNames collect: [:ea |
		repo loadVersionFromFileNamed: ea].
	versions do: [:ea | ea load].! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
repo: mcRepository

	repo := mcRepository! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:44'!
versionFileNames

	^ versionFileNames! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:43'!
versionFileNames: fileNames

	versionFileNames := fileNames! !

Object subclass: #CodeSightSarBuilder
	instanceVariableNames: 'zip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Install'!

!CodeSightSarBuilder class methodsFor: 'service' stamp: 'rkrk 11/27/2009 15:14'!
create

	"self create"
	^ self new create! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'bs 1/25/2010 10:19:49.792'!
addFiles

	| paths |
	paths := {self downloadLatestSwaUtilVersion.
	self downloadMethodWrapperMczs.
	self downloadLatestCodeSightVersion.
	self	downloadLatestCodeSightTestExamplesVersion} gather: [:ea |
		(ea isCollection and: [ea isString not]) ifTrue: [ea] ifFalse: [{ea}]]. "flatten"
	paths do: [:path | 
		zip addFile: path as: (path subStrings: '/\') last].! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 13:28'!
addPostScript

	zip addString: self postscript as: 'install/postscript'.! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 13:28'!
addPreamble

	zip addString: self preamble as: 'install/preamble'.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:12'!
create

	self
		createZip;
		addPreamble;
		addPostScript;
		addFiles;
		writeAndCloseZip.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 13:30'!
createZip

	zip := ZipArchive new.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightTestExamplesVersion

	^ self fromCodeSightRepoDownload: 'CodeSightTestExamples-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightVersion

	^ self fromCodeSightRepoDownload: 'CodeSight-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:57.281'!
downloadLatestSwaUtilVersion

	^ self fromSwaUtilitiesRepoDownload: 'SwaUtil-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:45'!
downloadMethodWrapperFromSqueakMap

	| squeakMap package |
	squeakMap := SMSqueakMap default.
	squeakMap objects ifNil: [
		squeakMap inspect.
		self error: 'There is a problem with the SqueakMap instance, inst var objects should be a dictionary but is nil. Please fix it and restart the build process!!'].
	package := squeakMap packageWithNameBeginning: 'MethodWrappers'.
	^ (SMInstaller forPackageRelease: package lastRelease)
		download;
		fullFileName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:59'!
downloadMethodWrapperMcz

	^ self fromCodeSightRepoDownload: 'MethodWrappers'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:30'!
downloadMethodWrapperMczs

	^ {self fromCodeSightRepoDownload: 'MethodWrappers-'. "newest"
	self fromCodeSightRepoDownload: 'Methodwrappers-rkrk.1'. "for non trunk images"}
	! !

!CodeSightSarBuilder methodsFor: 'default' stamp: 'rkrk 11/27/2009 15:14'!
filename

	^ 'CodeSight-' , Date today yyyymmdd , '.sar'! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromCodeSightRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/CodeSight'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromRepo: repoUrl download: packageOrVersionName

	| repo versionName filename mimeDoc |
	repo := MCHttpRepository
		location: repoUrl
		user: ''
		password: ''.
	versionName := repo allVersionNames detect: [:ea | ea startsWith: packageOrVersionName]. "assume latest first. Seems to work..."
	filename := versionName , '.mcz'.
	mimeDoc := (Url absoluteFromText:  (repo urlForFileNamed: filename)) retrieveContents.
	^ FileStream
		forceNewFileNamed: filename
		do: [:s | s binary. s nextPutAll: mimeDoc content. s fullName].! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:23.85'!
fromSwaUtilitiesRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 15:10'!
postscript

	^ 'CSCoverageTracingWrapper initialize'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:59.759'!
preamble

	^ String streamContents: [:s |
		s
			nextPutAll: self preambleSwaUtilInstall; cr;
			nextPutAll: self preambleMethodWrapperInstall; cr;
			nextPutAll: self preambleCodeSightInstall; cr;
			nextPutAll: self preambleCodeSightTestExamplesInstall; cr].! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 15:04'!
preambleCodeSightInstall

	^ '(self membersMatching: ''CodeSight-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:17'!
preambleCodeSightTestExamplesInstall

	^ '(self membersMatching: ''CodeSightTestExamples-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:45'!
preambleMethodWrapperInstall

	^ '"For trunk image choose newest version, for olde images choose 1.mcz"
	SystemVersion current highestUpdate <= 7179
		ifTrue: [self installMember: (self memberNamed: ''Methodwrappers-rkrk.1.mcz'')]
		ifFalse: [(self membersMatching: ''MethodWrappers-*.mcz'') do: [:ea |
					ea fileName ~= ''Methodwrappers-rkrk.1.mcz'' ifTrue: [
						self installMember: ea]]].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 03:01'!
preambleSWAUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:24.481'!
preambleSwaUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:15'!
writeAndCloseZip

	zip
		writeToFileNamed: self filename;
		close.! !

Object subclass: #DummyMonitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-TestTracer'!

!DummyMonitor methodsFor: 'as yet unclassified' stamp: 'bs 1/16/2010 11:10'!
critical: aBlock
	^ aBlock value! !

!Object methodsFor: '*SightC' stamp: 'bs 4/28/2009 18:20'!
debugAndUninstallBreakpointBefore
	(Debugger context: thisContext)
		debug: 'Debugger' executeBefore: [:debugger | 
			debugger down.
			BreakpointManager unInstall: debugger selectedContext method.
			debugger restartAfterMethodChanged.].
	Processor activeProcess suspend.! !

Object subclass: #SCodeSight
	instanceVariableNames: 'instrumentor testRunner csTestDriver packageChooser runningTestMethod isActiveCounter isActive isSystemInstance wasCleanedUp systemEventAnalyzer testActorId developmentActorId maintenanceActorId distributionMode managedPackages testReplicator maintenanceReplicator openEvents actor'
	classVariableNames: 'Instance Instances SourceCodeMonitor'
	poolDictionaries: ''
	category: 'SightC-TestTracer'!

!SCodeSight class methodsFor: 'synchronizing' stamp: 'bs 1/25/2010 18:55:14.46'!
sourceCodeMonitor
	" SourceCodeMonitor := nil"
	^ SourceCodeMonitor ifNil: [ SourceCodeMonitor := DummyMonitor new ]! !

!SCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
activateTracing
	isActiveCounter ifNil: [isActiveCounter := 0].
	isActiveCounter := isActiveCounter + 1.
	isActive := isActiveCounter > 0.! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 7/4/2010 12:48:08.022'!
actor
	actor ifNil: [ 
		actor := SActor new.
		actor codeSight: self ].
	^ actor! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 3/2/2010 22:37:44.467'!
addToManagedPackages: aPackageInfo
	self managedPackages add: aPackageInfo.
	^ self instrumentor instrumentPackage: aPackageInfo.! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:23'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		children: (self toolButtons collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:16'!
buildWith: aBuilder
	| windowSpec |
	windowSpec := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	
	^aBuilder build: windowSpec
	! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'replica 5/10/2010 20:44:15.502'!
cleanUp
	(self wasCleanedUp)
		ifFalse: [
			self isSystemInstance ifTrue: [ self uninstallFromSystem ].
			self systemNotifier noMoreNotificationsFor: self.
			self csTestRunner cleanUp.
			self instrumentor cleanUp.
			self wasCleanedUp: true ]! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/4/2010 14:34'!
close
	self cleanUp! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/5/2010 11:56:10.474'!
createExtensionBlock
	^ [ :aMethod | | extensionClass |
		
		aMethod isTestMethod
			ifTrue: [ STestMethodExtension new ]
			ifFalse: [ 
				SNonTestMethodExtension new
					codeSight: self;
					yourself ]  ]! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/5/2010 10:49:52.299'!
createWeavingInstrumentor
	^ SInstrumentor weavingAndCreateExtensionsWith: self createExtensionBlock.! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/5/2010 10:41:29.911'!
createWrappingInstrumentor
	^ SInstrumentor wrappingAndCreateExtensionsWith: self createExtensionBlock.! !

!SCodeSight methodsFor: 'accessing' stamp: 'replica 5/20/2010 20:45:37.298'!
csTestDriver
	^ csTestDriver! !

!SCodeSight methodsFor: 'accessing' stamp: 'replica 5/20/2010 20:45:37.31'!
csTestDriver: anObject
	csTestDriver := anObject! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ testRunner! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner: anObject
	testRunner := anObject! !

!SCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
deactivateTracing
	isActiveCounter ifNil: [isActiveCounter := 0].
	isActiveCounter := isActiveCounter - 1.
	isActive := isActiveCounter > 0.! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:53:31.317'!
developmentActorId
	^ developmentActorId 
		ifNil: [ developmentActorId := ActorId localhostPort: self developmentActorPort ]! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:49:48.69'!
developmentActorPort
	^ 12000! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:24:45.391'!
distributionMode
	^ distributionMode ifNil: [ distributionMode := false ]! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:12.178'!
distributionMode: aBoolean
	^ distributionMode := aBoolean.! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 08:58'!
extent
	^ 200 @ 250! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/4/2010 14:12'!
finalize
	self cleanUp! !

!SCodeSight methodsFor: 'system event handling' stamp: 'bs 7/18/2010 12:33:16.375'!
handle: aSystemEvent affectedClass: aClass
	| codeSightEvent |
	(self isClassManaged: aClass)
		ifTrue: [ 
			codeSightEvent := self systemEventAnalyzer analyze: aSystemEvent.
			codeSightEvent handle: self ].! !

!SCodeSight methodsFor: 'system event handling' stamp: 'bs 1/11/2010 10:09'!
handleClassEvent: anEvent
	self handle: anEvent affectedClass: anEvent item! !

!SCodeSight methodsFor: 'system event handling' stamp: 'bs 3/2/2010 13:48:32.141'!
handleMethodEvent: anEvent
	self handle: anEvent affectedClass: anEvent itemClass! !

!SCodeSight methodsFor: 'system event handling' stamp: 'replica 2/24/2010 16:27:27.72'!
handleSystemEvent: anEvent
	self runsDistributed
		ifTrue: [ self replicateModification: anEvent ].
	
	(anEvent itemKind == #class) ifTrue: [ self handleClassEvent: anEvent ].
	(anEvent itemKind == #method) ifTrue: [ self handleMethodEvent: anEvent ].! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 7/5/2010 10:35:35.35'!
initialize
	self instrumentor: self createWrappingInstrumentor.
	self csTestRunner: STestRunner new.
	self csTestRunner codeSight: self.
	self csTestDriver: STddMonitor new.
	self csTestDriver csTestRunner: self csTestRunner.
	self csTestRunner tddMonitor: self csTestDriver.
	
	self packageChooser: SPackageChooser new.
	self packageChooser codeSight: self.
	{ #class. #method. #protocol. #category } do: [ :itemKind |
		self systemNotifier notify: self ofSystemChangesOfItem: itemKind  using: #handleSystemEvent: ].
	
	"self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	self systemNotifier notify: self ofSystemChangesOfItem: #method  using: #handleMethodEvent:."! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 7/4/2010 12:48:36.078'!
installIntoSystem
	SInfo instance: (SRealInfo new codeSight: self; yourself).
	self csTestRunner addDependent: SInfo instance.
	self isSystemInstance: true
		
	
	! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 13:34'!
installUninstallLabel
	^ self isSystemInstance
		ifTrue: [ 'uninstall from system' ]
		ifFalse: [ 'install into system' ].! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:42.226'!
instrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor instrumentPackage: aPackageInfo ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor
	^ instrumentor! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor: anObject
	instrumentor := anObject! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 2/25/2010 10:52:39.006'!
isClassManaged: aClass
	^ (self instrumentor isClassInstrumented: aClass) 
		or: [self managedPackages includes: (self packageOfClass: aClass) ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:40'!
isSystemInstance
	^ isSystemInstance ifNil: [ isSystemInstance := false ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 2/25/2010 10:33:55.565'!
isSystemInstance: anObject
	isSystemInstance := anObject.
	self changed: #installUninstallLabel. ! !

!SCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
isTracingActivated
	^ isActive ifNil: [isActive := false]! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/3/2010 20:11'!
label
	^ 'CodeSight'! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/2/2010 21:17:49.694'!
maintainCoverage: testMethodNames
	| testMethodsToRun testsToCoverageData coverageData |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner reset; runTestMethods: testMethodsToRun.
	
	testsToCoverageData := Dictionary new.
	testMethodsToRun do: [ :testMethod | 
		coverageData := testsToCoverageData 
				at: testMethod qualifiedName
				put: Dictionary new.
		
		testMethod coveredMethodsStatistics keysAndValuesDo: [ :method :stats |
			coverageData 
				at: (method qualifiedName)
				put: (stats receiverClasses collect: [:ea | ea name ]) ] ].
		
	self developmentActorId testCoverage: testsToCoverageData.! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/25/2010 10:55:39.813'!
maintenanceActorId
	^ maintenanceActorId 
		ifNil: [ maintenanceActorId := ActorId localhostPort: self maintenanceActorPort ]! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:53:54.166'!
maintenanceActorPort
	^ 12007! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:23.295'!
maintenanceReplicator
	^ maintenanceReplicator! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:33.135'!
maintenanceReplicator: anObject
	maintenanceReplicator := anObject! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:33.709'!
makeDistributed
	self distributionMode: true
	! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:27.222'!
makeStandalone
	self distributionMode: false! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 09:50:03.578'!
managedPackages
	^ managedPackages ifNil: [ managedPackages := WeakSet new ]! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/2/2010 21:13:53.811'!
modification: aCommandString
	Compiler evaluate: aCommandString! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/4/2010 14:38'!
open
	^ ToolBuilder open: self! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'replica 2/24/2010 17:46:37.084'!
openEvents
	^ openEvents ifNil: [ openEvents := SharedQueue2 new ]! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:15'!
openPackageChooser
	^ self packageChooser open! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:32'!
openTestDriver! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:15'!
openTestRunner
	^ self csTestRunner open! !

!SCodeSight methodsFor: 'distribution-ui' stamp: 'bs 2/23/2010 09:29:52.58'!
operationModeLabel
	^ self runsDistributed
		ifTrue: [ 'standalone mode' ]
		ifFalse: [ 'distribution mode' ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:37'!
packageChooser
	^ packageChooser! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:37'!
packageChooser: anObject
	packageChooser := anObject! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 1/4/2010 16:43'!
packageOfClass: aClass
	^ PackageOrganizer default
		packageOfClass: aClass
		ifNone: [PackageInfo named: (Smalltalk organization categoryOfElement: aClass name)].! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 11:49:00.632'!
removeFromManagedPackages: aPackageInfo
	self managedPackages remove: aPackageInfo.
	^ self instrumentor uninstrumentPackage: aPackageInfo.! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/25/2010 10:58:56.703'!
replicateModification: aSystemEvent
	| command |
	command := self testReplicator handle: aSystemEvent.
	{ self testActorId. self maintenanceActorId } do: [ :actorId | 
		actorId modification: command ].! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/25/2010 10:59:26.695'!
resetOpenEvents
	^ openEvents := SharedQueue2 new! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/2/2010 21:17:53.481'!
runTests: testMethodNames
	| testMethodsToRun |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner reset; runTestMethods: testMethodsToRun.
	self developmentActorId testResult: self csTestRunner result copy.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/23/2010 13:54:13.983'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!SCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
runningTestMethod
	^ runningTestMethod
	! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:45.798'!
runsDistributed
	^ self distributionMode! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:24:18.858'!
runsStandalone
	self runsDistributed not! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:15.208'!
startActorOnPort: anInteger

	self actor startOn: anInteger.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:10.874'!
startDevelopmentActor
	self startActorOnPort: self developmentActorPort! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:13:09.607'!
startMaintenanceActor
	self startReplicaActorOnPort: self maintenanceActorPort.
	self csTestRunner tddAutoRunStop.
	self switchToWeavingInstrumentor.
	self activateTracing.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:38:55.908'!
startReplicaActorOnPort: anInteger
	
	Utilities setAuthorInitials: 'replica'.
	self actor startOn: anInteger.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:45:09.773'!
startTestActor
	self startReplicaActorOnPort: self testActorPort.
	self uninstrumentCode.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:06.365'!
switchToDistributedMode
	self
		turnOffStandaloneMode;
		turnOnDistributedMode.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/23/2010 11:50:56.977'!
switchToStandaloneMode
	self 
		turnOffDistributedMode;
		turnOnStandaloneMode;
		makeStandalone.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 7/1/2010 10:18:31.561'!
switchToWeavingInstrumentor
	self uninstrumentCode.
	self instrumentor: self createWeavingInstrumentor.
	self instrumentCode.! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:42.907'!
systemEventAnalyzer
	^ systemEventAnalyzer ifNil: [ systemEventAnalyzer := SSystemEventAnalyzer new ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:47'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/25/2010 10:55:27.866'!
testActorId
	^ testActorId 
		ifNil: [ testActorId := ActorId localhostPort: self testActorPort ]! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:49:39.406'!
testActorPort
	^ 12003! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 2/25/2010 12:08:23.61'!
testCoverage: testsToCoverageData
	| aTestMethod |
	testsToCoverageData keysAndValuesDo: [ :aTestName :coverageData |
		aTestMethod := CompiledMethod fromQualifiedName: aTestName.
		coverageData keysAndValuesDo: [ :aMethodName :classSymbols | 
			aTestMethod 
				called: (CompiledMethod fromQualifiedName: aMethodName) unwrappedMethod
				receiverClasses: (classSymbols collect: [ :ea | Smalltalk classNamed: ea ]) ]
		].
	self openEvents next afterRunningTestsOn: self csTestRunner.! !

!SCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
testMethodGoingToRun: aCompiledMethod
	runningTestMethod := aCompiledMethod
	! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:47.025'!
testReplicator
	^ testReplicator! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:54.286'!
testReplicator: anObject
	testReplicator := anObject! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/3/2010 09:02:22.028'!
testResult: aTestResult
	self csTestRunner 
		result: aTestResult;
		updateResults;
		updateResultsInHistory! !

!SCodeSight methodsFor: 'distribution-ui' stamp: 'bs 2/23/2010 11:52:13.677'!
toggleOperationMode
	self runsDistributed
		ifTrue: [ self switchToStandaloneMode ]
		ifFalse: [ self switchToDistributedMode ].
	self changed: #operationModeLabel.! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 14:16'!
toggleSystemInstallation
	self isSystemInstance
		ifTrue: [ self uninstallFromSystem ]
		ifFalse: [ self installIntoSystem ].
		
	
	! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 2/23/2010 09:03:40.812'!
toolButtons
	^ #(( 'Package Chooser' #openPackageChooser )
		( 'Test Runner' #openTestRunner )
		( 'Test Driver' #openTestDriver )
		( #installUninstallLabel #toggleSystemInstallation )
		( #operationModeLabel #toggleOperationMode ))! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 11:00:03.722'!
turnOffDistributedMode
	self actor stop.
	self testActorId close.
	self maintenanceActorId close.
	self testReplicator stopReplicaAndCleanUp.
	self maintenanceReplicator stopReplicaAndCleanUp.
	self resetOpenEvents.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:44:36.47'!
turnOffStandaloneMode! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 7/4/2010 12:48:41.38'!
turnOnDistributedMode
	| runningProcessId tmpTestReplicator tmpMaintenanceReplicator |
	tmpTestReplicator := (SReplicator newTestReplicaOnPort: self testActorPort).
	tmpMaintenanceReplicator := (SReplicator newMaintenanceReplicaOnPort: self maintenanceActorPort).
	
	runningProcessId := self runningProcessId.
	SmalltalkImage current snapshot: true andQuit: false.
	"check whether this is the process that created the replica"
	(runningProcessId == self runningProcessId) 
		ifTrue: [
			tmpTestReplicator createAndStartReplica.
			
			SmalltalkImage current snapshot: true andQuit: false.
			(runningProcessId == self runningProcessId) 
				ifTrue: [
					tmpMaintenanceReplicator createAndStartReplica.
					self testReplicator: tmpTestReplicator.
					self maintenanceReplicator: tmpMaintenanceReplicator.
					self startDevelopmentActor.
					self makeDistributed. ]
				ifFalse: [
					self startMaintenanceActor ] ]
		ifFalse: [
			self startTestActor ].! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:44:51.8'!
turnOnStandaloneMode! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 7/4/2010 12:48:24.636'!
uninstallFromSystem
	self csTestRunner removeDependent: SInfo instance.
	SInfo resetToZeroInfo.
	self isSystemInstance: false 
		
	
	! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:46.751'!
uninstrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor uninstrumentPackage: aPackageInfo ]! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/14/2010 15:04'!
wasCleanedUp
	^ wasCleanedUp ifNil: [ wasCleanedUp := false ]! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/14/2010 15:04'!
wasCleanedUp: aBoolean
	^ wasCleanedUp := aBoolean! !

SCodeSight subclass: #SCodeSightForDistributionRequestTests
	instanceVariableNames: 'distributionTestsDevelopmentActor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-DistributionTests'!

!SCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:57:09.767'!
developmentActorId
	^ self distributionTestsDevelopmentActor ! !

!SCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:18.663'!
distributionTestsDevelopmentActor
	^ distributionTestsDevelopmentActor 
		ifNil: [ distributionTestsDevelopmentActor := SDistributionTestsDevelopmentActor new ]! !

Object subclass: #SDistributionTestsDevelopmentActor
	instanceVariableNames: 'receivedTestResult receivedTestCoverage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-DistributionTests'!

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.603'!
receivedTestCoverage
	^ receivedTestCoverage! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.605'!
receivedTestResult 
	^ receivedTestResult! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.607'!
testCoverage: coverageData
	receivedTestCoverage := coverageData! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.609'!
testResult: aTestResult
	receivedTestResult := aTestResult! !

Object subclass: #SEvent
	instanceVariableNames: 'systemEvent testMethodsToRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SEvent class methodsFor: 'instance creation' stamp: 'replica 2/23/2010 15:50:14.959'!
systemEvent: anEvent
	^ self new 
		systemEvent: anEvent; 
		yourself! !

!SEvent methodsFor: 'handling' stamp: 'bs 3/1/2010 16:26:13.359'!
handle: codeSight
	codeSight instrumentor handle: self systemEvent.! !

!SEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:16.542'!
systemEvent
	^ systemEvent! !

!SEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:29.986'!
systemEvent: anObject
	systemEvent := anObject! !

!SEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:35.412'!
testMethodsToRun
	^ testMethodsToRun! !

!SEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:46.832'!
testMethodsToRun: anObject
	testMethodsToRun := anObject! !

SEvent subclass: #SModificationEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SModificationEvent class methodsFor: 'instance creation' stamp: 'bs 1/16/2010 00:14'!
systemEvent: anEvent
	^ self new 
		systemEvent: anEvent; 
		yourself! !

!SModificationEvent methodsFor: 'covered entities' stamp: 'bs 1/15/2010 09:17'!
affectedMethods
	self subclassResponsibility! !

!SModificationEvent methodsFor: 'test-running' stamp: 'bs 3/15/2010 20:45:55.318'!
afterRunningTestsOn: aTestRunner
	self recordEffectsOn: aTestRunner.! !

!SModificationEvent methodsFor: 'test-running' stamp: 'bs 3/15/2010 21:09:02.53'!
beforeRunningTestsOn: aTestRunner
	self testMethodsToRun: self collectTestMethodsToRun.
	! !

!SModificationEvent methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:15'!
collectTestMethodsToRun
	self subclassResponsibility! !

!SModificationEvent methodsFor: 'handling' stamp: 'bs 7/5/2010 13:38:04.215'!
handle: codeSight
	| testRunner |
	testRunner := codeSight csTestRunner.
	testRunner isInTddAutoRunMode
		ifFalse: [ codeSight instrumentor handle: self systemEvent ]
		ifTrue: [
			self beforeRunningTestsOn: testRunner.
			self resetCoverageData.
			codeSight instrumentor handle: self systemEvent.
			self processOn: testRunner.
			codeSight runsDistributed
				ifTrue: [ codeSight openEvents nextPut: self ] ].
	
	! !

!SModificationEvent methodsFor: 'test-driving' stamp: 'bs 7/20/2010 11:12:45.083'!
processOn: aTestRunner
	| codeSight testsToRun testMethodNames |
	codeSight := aTestRunner codeSight.
	testsToRun := aTestRunner defectTestMethods, self testMethodsToRun.
	codeSight runsDistributed
		ifFalse: [
			codeSight activateTracing.
			aTestRunner runTestsInSuite: testsToRun.
			codeSight deactivateTracing.
			self afterRunningTestsOn: aTestRunner	]
		ifTrue: [
			testMethodNames := testsToRun collect: [ :ea | ea qualifiedName ].
			codeSight testActorId runTests: testMethodNames.
			codeSight maintenanceActorId maintainCoverage: testMethodNames ]! !

!SModificationEvent methodsFor: 'test-driving' stamp: 'bs 1/15/2010 16:19'!
recordEffectsOn: aTddMonitor! !

!SModificationEvent methodsFor: 'covered entities' stamp: 'bs 7/5/2010 13:50:52.718'!
resetCoverageData
	self resetCoverageOfAffectedMethods.
	self resetCoverageOfTests.! !

!SModificationEvent methodsFor: 'covered entities' stamp: 'bs 4/23/2010 11:11:35.942'!
resetCoverageOfAffectedMethods
	self affectedMethods do: [ :ea | ea resetCoveringTestMethods ]! !

!SModificationEvent methodsFor: 'covered entities' stamp: 'bs 7/5/2010 13:50:37.958'!
resetCoverageOfTests
	self testMethodsToRun do: [ :testMethod | testMethod resetCoveredMethodsStatistics ].! !

SModificationEvent subclass: #SNonTestMethodAndRemovedEventBase
	instanceVariableNames: 'oldDefects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

SNonTestMethodAndRemovedEventBase subclass: #SAddedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

SAddedEvent subclass: #SMethodAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SMethodAdded methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:14'!
addedMethod
	^ self systemEvent item! !

!SMethodAdded methodsFor: 'covered entities' stamp: 'bs 7/5/2010 13:43:25.312'!
affectedMethods
	^ self addedMethod overriddenAndOverridingMethods! !

!SMethodAdded methodsFor: 'test-driving' stamp: 'bs 7/5/2010 13:43:33.773'!
collectTestMethodsToRun
	^ (self affectedMethods
		gather: [ :supOrSubMethod | supOrSubMethod coveringTestMethods ]) 
			asIdentitySet! !

!SMethodAdded methodsFor: 'test-driving' stamp: 'bs 1/17/2010 21:50'!
recordEffectsOn: aTestDriver
	aTestDriver tddMonitor nonTestMethodAddedOrModified: self addedMethod
	! !

SNonTestMethodAndRemovedEventBase subclass: #SModifiedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

SModifiedEvent subclass: #SClassModified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SClassModified methodsFor: 'covered entities' stamp: 'bs 1/17/2010 15:18'!
affectedMethods
	| modifiedClass |
	modifiedClass := self modifiedClass.
	^ { modifiedClass. modifiedClass class }
		gather: [ :class | class withAllSubclasses 
			gather: [ :eachClass | eachClass methodDict values 
				 select: [ :eachMethod | eachMethod isTestMethod not ] ] ]! !

!SClassModified methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:17'!
collectTestMethodsToRun
	^ self testMethods, (self affectedMethods gather: [ :ea | ea coveringTestMethods ]).
		! !

!SClassModified methodsFor: 'system event accessing' stamp: 'bs 1/17/2010 15:24'!
modifiedClass
	^ self wasInstanceDefinitionModified
		ifTrue: [ self systemEvent oldItem ]
		ifFalse: [ self systemEvent item ].! !

!SClassModified methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 16:51'!
testMethods
	^ self modifiedClass isTestCaseClass
		ifTrue: [ self modifiedClass methodDict values select: [ :ea | ea isTestMethod ]  ]
		ifFalse: [ Set new ]! !

!SClassModified methodsFor: 'system event accessing' stamp: 'bs 1/17/2010 21:36'!
wasInstanceDefinitionModified
	^ self systemEvent areInstVarsModified
		or: [ self systemEvent isSuperclassModified ]! !

SModifiedEvent subclass: #SMethodModified
	instanceVariableNames: 'previouslyFixedTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SMethodModified methodsFor: 'covered entities' stamp: 'bs 1/17/2010 21:49'!
affectedMethods
	^ Set with: self oldMethod! !

!SMethodModified methodsFor: 'test-running' stamp: 'bs 3/15/2010 20:45:47.623'!
afterRunningTestsOn: aTestRunner
	super afterRunningTestsOn: aTestRunner.
	
	"withTracingWrapper uninstall."
	previouslyFixedTests
		select: [ :ea | self newMethod coveringTestMethods includes: ea ]
		thenDo: [ :ea | self newMethod fixes: ea ].! !

!SMethodModified methodsFor: 'test-running' stamp: 'bs 3/1/2010 18:55:00.383'!
beforeRunningTestsOn: aTestRunner
	super beforeRunningTestsOn: aTestRunner.
	previouslyFixedTests := self oldMethod fixedTestMethods.
	
	"selector := self newMethod selector.
	methodClass := self newMethod methodClass.
	
	withTracingWrapper := CSWithTracingWrapper 
			on: selector inClass: methodClass inContext: aTestRunner codeSight.
	withTracingWrapper install. "! !

!SMethodModified methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:17'!
collectTestMethodsToRun
	^ self oldMethod coveringTestMethods "which are not available for modified version"! !

!SMethodModified methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:16'!
newMethod
	^ self systemEvent item! !

!SMethodModified methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:16'!
oldMethod
	^ self systemEvent oldItem! !

!SMethodModified methodsFor: 'test-driving' stamp: 'bs 1/17/2010 21:49'!
recordEffectsOn: aTestDriver
	aTestDriver tddMonitor nonTestMethodAddedOrModified: self newMethod
	! !

!SNonTestMethodAndRemovedEventBase methodsFor: 'test-running' stamp: 'replica 5/20/2010 20:15:25.023'!
afterRunningTestsOn: aTestRunner
	| newDefects |
	super afterRunningTestsOn: aTestRunner.
	newDefects := aTestRunner defectTestMethods.
	aTestRunner tddMonitor testsTurnedGreen: (oldDefects difference: newDefects).
	"aTestRunner tddMonitor
		modification: self modifiedNonTestMethods 
		brokeTests: (newDefects difference: oldDefects)
		previouslyFixedTests: self previouslyFixedTests."
	"die zeile drber muss eigentlich weg und da muss so was hin wie, modification: brokeTests:"! !

!SNonTestMethodAndRemovedEventBase methodsFor: 'test-running' stamp: 'bs 3/1/2010 18:54:54.186'!
beforeRunningTestsOn: aTestRunner
	super beforeRunningTestsOn: aTestRunner.
	oldDefects := aTestRunner defectTestMethods.! !

!SNonTestMethodAndRemovedEventBase methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:16'!
collectTestMethodsToRun
	^ (self affectedMethods gather: [ :ea | ea coveringTestMethods ]) asSet! !

SNonTestMethodAndRemovedEventBase subclass: #SRemovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

SRemovedEvent subclass: #SClassRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SClassRemoved methodsFor: 'covered entities' stamp: 'bs 1/15/2010 10:49'!
affectedMethods
	^ { self removedClass. self removedClass class } 
		gather: [ :eachClass | eachClass withAllSubclasses 
			gather: [ :eachSubclass | eachSubclass methodDict values 
				select: [ :eachMethod | eachMethod isTestMethod not ]  ] ]! !

!SClassRemoved methodsFor: 'system event processing' stamp: 'bs 1/16/2010 00:17'!
removedClass
	^ self systemEvent item! !

!SClassRemoved methodsFor: 'system event processing' stamp: 'bs 1/15/2010 11:34'!
removedMethods
	^ { self removedClass. self removedClass class } 
		gather: [ :eachClass | eachClass methodDict values ]! !

SRemovedEvent subclass: #SMethodRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SMethodRemoved methodsFor: 'covered entities' stamp: 'bs 1/15/2010 13:03'!
affectedMethods
	^ self removedMethod isTestMethod
		ifTrue: [ { } ]
		ifFalse: [ { self removedMethod } ]! !

!SMethodRemoved methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:17'!
removedMethod
	^ self systemEvent item! !

!SMethodRemoved methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 11:33'!
removedMethods
	^ { self removedMethod }! !

!SRemovedEvent methodsFor: 'test-running' stamp: 'bs 4/23/2010 09:52:31.761'!
beforeRunningTestsOn: aTestRunner
	self removedTestMethods do: [ :ea | aTestRunner testMethodRemoved: ea ].
	super beforeRunningTestsOn: aTestRunner! !

!SRemovedEvent methodsFor: 'test-driving' stamp: 'bs 4/23/2010 09:50:55.953'!
recordEffectsOn: aTestDriver
	self removedNonTestMethods do: [ :ea |  aTestDriver nonTestMethodRemoved: ea ].! !

!SRemovedEvent methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 12:53'!
removedMethods
	self subclassResponsibility! !

!SRemovedEvent methodsFor: 'system event accessing' stamp: 'bs 4/23/2010 09:50:35.445'!
removedNonTestMethods
	^ self removedMethods reject: [ :ea | ea isTestMethod ]! !

!SRemovedEvent methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 16:14'!
removedTestMethods
	^ self removedMethods select: [ :ea | ea isTestMethod ]! !

!SRemovedEvent methodsFor: 'covered entities' stamp: 'bs 4/23/2010 12:13:53.068'!
resetCoverageOfAffectedMethods
	super resetCoverageOfAffectedMethods.
	self removedTestMethods do: [ :ea | ea resetCoveredMethodsStatistics ].! !

SModificationEvent subclass: #STestMethodAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!STestMethodAdded methodsFor: 'covered entities' stamp: 'bs 1/16/2010 00:19'!
affectedMethods
	^ Set new! !

!STestMethodAdded methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:18'!
collectTestMethodsToRun
	^ Set with: self testMethod! !

!STestMethodAdded methodsFor: 'test-driving' stamp: 'bs 7/20/2010 08:58:52.761'!
recordEffectsOn: aTestRunner
	(aTestRunner result isDefect: self testMethod)
		ifTrue: [ aTestRunner tddMonitor newBehaviorSpecified: self testMethod ]
		ifFalse: [ aTestRunner tddMonitor testsTurnedGreen: {self testMethod} ].! !

!STestMethodAdded methodsFor: 'covered entities' stamp: 'bs 7/5/2010 13:52:49.124'!
resetCoverageOfTests
	! !

!STestMethodAdded methodsFor: 'system event accessing' stamp: 'bs 1/17/2010 21:41'!
testMethod
	^ self systemEvent item! !

STestMethodAdded subclass: #STestMethodModified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!STestMethodModified methodsFor: 'system event accessing' stamp: 'bs 4/23/2010 11:15:04.198'!
newTestMethod
	^ self systemEvent item! !

!STestMethodModified methodsFor: 'system event accessing' stamp: 'bs 4/23/2010 11:14:41.46'!
oldTestMethod
	^ self systemEvent oldItem! !

!STestMethodModified methodsFor: 'covered entities' stamp: 'bs 7/5/2010 13:51:20.325'!
resetCoverageOfTests
	self oldTestMethod resetCoveredMethodsStatistics.! !

SEvent subclass: #SNoOpEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SNoOpEvent methodsFor: 'handling' stamp: 'bs 3/1/2010 16:26:26.536'!
handle: codeSight
	super handle: codeSight! !

Object subclass: #SEventHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:36:12.918'!
categoryAdded: anAddedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:36:08.189'!
categoryRemoved: aRemovedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:36:04.333'!
categoryRenamed: aRenamedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classAdded: anAddedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classModified: aModifiedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:35:18.688'!
classRecategorized: aRecategorizedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classRemoved: aRemovedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classRenamed: aRenamedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classReorganized: aReorganizedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 7/4/2010 14:00:04.567'!
handle: anEvent
	^ self perform: anEvent sEventHandlerSelector with: anEvent.! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
methodAdded: anAddedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
methodModified: aModifiedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 14:00'!
methodRecategorized: aRecategorizedEvent
	^ nil! !

!SEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 14:00'!
methodRemoved: aRemovedEvent
	^ nil! !

SEventHandler subclass: #SReplicaCommandCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Distribution'!

!SReplicaCommandCreator methodsFor: 'system event handling' stamp: 'bs 1/28/2010 21:29:26.234'!
classAdded: anAddedEvent! !

SEventHandler subclass: #SReplicaService
	instanceVariableNames: 'listenSocket servingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Distribution'!

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:40.695'!
receiveAndProcess: aSocket
	| receivedMessage |
	receivedMessage := SReplicateMessage receiveFrom: aSocket.
	receivedMessage applyCommand.
	self codeSight 
		ifNotNil: [ self codeSight csTestRunner result copy ]! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 08:59:23.349'!
runLoop
	"Run the server's connection accept loop."
	| newConnectionSocket |
	
	[listenSocket isValid]
		whileTrue: 
			[[newConnectionSocket := listenSocket waitForAcceptFor: 10]
				on: ConnectionTimedOut
				do: [:ex | newConnectionSocket := nil].
			 newConnectionSocket isNil
				ifFalse:
					[ self serve: newConnectionSocket ] ]! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:40.687'!
serve: aSocket
	| receivedMessage |
	[aSocket isValid and: [aSocket isConnected] ] 
		whileTrue: [
			aSocket waitForDataIfClosed: [ ].
			receivedMessage := SReplicateMessage receiveFrom: aSocket.
			receivedMessage applyCommand ] 
	! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 16:38:39.339'!
servicePriority
	^ Processor lowIOPriority! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 09:43:23.521'!
startOn: portNumber
	
	listenSocket := Socket newTCP.
	listenSocket listenOn: portNumber backlogSize: 2.
	listenSocket isValid ifFalse: [^self error: 'Could not create server socket'].
	servingProcess := [self runLoop] forkAt: self servicePriority.! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 19:21:28.985'!
stop
	servingProcess terminate.
	listenSocket closeAndDestroy.! !

SEventHandler subclass: #SReplicator
	instanceVariableNames: 'replicaName servicePort clientSocket replicaProcess actorId'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'SightC-Distribution'!

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:14.991'!
existsInstanceWithName: aName orPort: anInteger
	^ self instances 
		anySatisfy: [ :aReplicator | 
			(aReplicator replicaName = aName) 
				or: [ aReplicator servicePort = anInteger ] ]! !

!SReplicator class methodsFor: 'class initialization' stamp: 'bs 1/27/2010 22:08:28.259'!
initialize
	" self initialize "
	super initialize.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!SReplicator class methodsFor: 'accessing' stamp: 'bs 2/8/2010 18:14:39.907'!
instances
	" Instances := nil "
	^ Instances ifNil: [ Instances := WeakSet new ]! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 1/27/2010 22:29:37.5'!
new
	self error: 'only use newWithReplicaName: '! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:09.773'!
newMaintenanceReplica
	^ self newMaintenanceReplicaOnPort: 9998.! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:15.342'!
newMaintenanceReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'maintenance'
		servingOnPort: anInteger.! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:49.034'!
newReplicaNamed: aName servingOnPort: anInteger
	(self existsInstanceWithName: aName orPort: anInteger)
		ifTrue: [ self error: ('there already exists a replicated image ',
					'with name: {1} or port: {2}' format: {aName asString. anInteger asString}) ].
	
	^ self instances add: ( 
		super new 
			replicaName: aName; 
			servicePort: anInteger;
			yourself ).
			! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:40.482'!
newTestReplica
	^ self newTestReplicaOnPort: 9999! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:10.667'!
newTestReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'testFeedback'
		servingOnPort: anInteger! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:04:59.818'!
remove: aReplicator
	self instances remove: aReplicator ifAbsent: []! !

!SReplicator class methodsFor: 'system startup' stamp: 'bs 1/27/2010 22:07:53.751'!
shutDown: aboutToQuit
	Transcript cr; show: 'shutDown: ', aboutToQuit asString.! !

!SReplicator class methodsFor: 'system startup' stamp: 'bs 1/27/2010 22:07:38.281'!
startUp: resuming
	Transcript cr; show: 'startUp: ', resuming asString.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:02:26.951'!
categoryAdded: anAddedEvent
	| categoryName |
	categoryName := anAddedEvent item.
	^ 'Smalltalk organization addCategory: ''{1}''' format: {categoryName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:49:16.088'!
categoryRemoved: aRemovedEvent
	| categoryName |
	categoryName := aRemovedEvent item.
	^ 'Smalltalk organization removeCategory: ''{1}''' format: {categoryName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:50:29.154'!
categoryRenamed: aRenamedEvent

	^ 'Smalltalk organization renameCategory: ''{1}'' toBe: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName.}! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:52.584'!
changeExtension
	^ self extensionForSuffix: FileDirectory changeSuffix.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:24.896'!
classAdded: anAddedEvent
	^ self classAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:08.601'!
classAddedOrModified: anEvent
	| addedOrModifiedClass | 
	addedOrModifiedClass := anEvent item.
	^ addedOrModifiedClass definition.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:48:24.449'!
classModified: aModifiedEvent
	^ self classAddedOrModified: aModifiedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 19:26:21.287'!
classRecategorized: aRecategorizedEvent
	| aClass |
	aClass := aRecategorizedEvent item.
	^ '{1} category: ''{2}''' format: {aClass. aClass category}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:13:32.5'!
classRemoved: aRemovedEvent
	| removedClass | 
	removedClass := aRemovedEvent item.
	^ '{1} removeFromSystem' format: {removedClass name}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 17:24:47.292'!
classRenamed: aRenamedEvent

	^ '{1} rename: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 20:01:02.201'!
classReorganized: aReorganizedEvent
	| aClass |
	aClass := aReorganizedEvent item.
	^ '{1} do: [ :eachCategory | {2} organization addCategory: eachCategory ]'
		format: {aClass organization categories. aClass}! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 2/23/2010 13:49:48.655'!
createAndStartReplica
	self 
		createCopyOfThisImage;
		startReplicaInNewProcess! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:08:22.907'!
createCopyOfThisImage
	
	self deleteReplicaImage.
	
	self squeakFileExtensions do: [ :extension | 
		FileDirectory default
			copyFileNamed: self nameOfThisImage, extension 
			toFileNamed: self nameOfReplicaImage, extension. ].! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:09:31.959'!
deleteReplicaImage

	self squeakFileExtensions do: [ :extension | 
		FileDirectory default 
			deleteFileNamed: self nameOfReplicaImage, extension ifAbsent: [] ]! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:29:49.375'!
extensionForSuffix: aSuffix
	^ FileDirectory dot, aSuffix
	! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:47.418'!
imageExtension
	^ self extensionForSuffix: FileDirectory imageSuffix.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:10.971'!
methodAdded: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 13:35:06.984'!
methodAddedOrModified: anEvent
	| source sourceWithDoubleEscapedStrings |
	source := anEvent item getSource asString.
	sourceWithDoubleEscapedStrings := source copyReplaceAll: '''' with: ''''''.
	^ '{1} compile: ''{2}''' 
		format: {anEvent itemClass. sourceWithDoubleEscapedStrings}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:18.132'!
methodModified: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 12:50:29.172'!
methodRemoved: aRemovedEvent
	^ '{1} removeSelector: #{2}' 
		format: {aRemovedEvent itemClass. aRemovedEvent itemSelector}! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/26/2010 22:05:12.719'!
nameOfReplicaImage
	^ self nameOfThisImage, '-replicated-', self replicaName! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:57.122'!
nameOfThisImage
	| imageFilePath imageFileName |
	imageFilePath := SmalltalkImage current imageName.
	imageFileName := self workingDirectory localNameFor: imageFilePath.
	^ FileDirectory baseNameFor: imageFileName.	! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 18:40:52.767'!
parentProcessId
	^ ThisOSProcess thisOSProcess ppid.! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:24:46.072'!
replicaImageName
	^ self nameOfReplicaImage! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:32:03.545'!
replicaImagePath
	^ self workingDirectory fullNameFor: (self replicaImageName, self imageExtension)! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.519'!
replicaName
	^ replicaName! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.52'!
replicaName: anObject
	replicaName := anObject! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.076'!
replicaProcess
	^ replicaProcess! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.077'!
replicaProcess: anObject
	replicaProcess := anObject! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 21:30:34.71'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.275'!
servicePort
	^ servicePort! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.276'!
servicePort: anObject
	servicePort := anObject! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:31:15.856'!
squeakFileExtensions
	^ { self imageExtension. self changeExtension } ! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 3/2/2010 21:42:11.538'!
startReplicaInNewProcess
	| squeakVmPath |
	squeakVmPath := OSProcess programName.
	self replicaProcess: (
		ExternalOSProcess concreteClass 
			programName: squeakVmPath 
			arguments: { "'-headless'." self replicaImagePath. } 
			initialEnvironment: nil ).
	self replicaProcess value.! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 2/25/2010 10:56:34.6'!
stopReplicaAndCleanUp
	self class remove: self.
	self 
		stopReplicaProcess;
		deleteReplicaImage! !

!SReplicator methodsFor: 'start / stop' stamp: 'replica 2/24/2010 22:09:37.556'!
stopReplicaProcess
	self replicaProcess 
		ifNotNil: [ self replicaProcess terminate ].
	! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:41.204'!
workingDirectory
	^ FileDirectory default! !

SEventHandler subclass: #SSystemEventAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Events'!

!SSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'bs 7/4/2010 12:48:32.817'!
analyze: aSystemEvent
	| anEventFactory |
	anEventFactory := (self handle: aSystemEvent) ifNil: [ SNoOpEvent ].
	^ anEventFactory systemEvent: aSystemEvent.! !

!SSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'bs 7/4/2010 12:48:13.22'!
classModified: aModifiedEvent	
	^ SClassModified! !

!SSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'bs 7/4/2010 12:48:13.875'!
classRemoved: aRemovedEvent
	^ SClassRemoved! !

!SSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'bs 7/4/2010 12:48:49.054'!
methodAdded: anAddedEvent 
	^ anAddedEvent item isTestMethod 
		ifTrue: [ STestMethodAdded ]
		ifFalse: [ SMethodAdded ].! !

!SSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'bs 7/4/2010 12:48:49.708'!
methodModified: aModifiedEvent
	^ aModifiedEvent oldItem isTestMethod 
		ifTrue: [ STestMethodModified ]
		ifFalse: [ SMethodModified ].! !

!SSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'bs 7/4/2010 12:48:30.074'!
methodRemoved: aRemovedEvent
	^ SMethodRemoved! !

Object subclass: #SFailedExpressionStyler
	instanceVariableNames: ''
	classVariableNames: 'RegisteredInstance'
	poolDictionaries: ''
	category: 'SightC-Text'!

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
initialize
	"self initialize"
	super initialize.
	self load.! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:33'!
load
	self registeredInstance: self new.
	SwaSourceTextStyler instance registerStyler: self registeredInstance.! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance
	^ RegisteredInstance! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance: anInstance
	^ RegisteredInstance := anInstance! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
unload
	SwaSourceTextStyler instance unregisterStyler: self registeredInstance.
	self registeredInstance: nil.! !

!SFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 7/4/2010 12:48:54.42'!
createFailedExpressionAttribute
	^ STextBackgroundColor new
		color: Color red darker;
		yourself! !

!SFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 12/31/2009 16:24'!
styleSource: aText of: aCompiledMethod
	| styledSourceText failedExpressionTextInterval |
	styledSourceText := aText.
	(aCompiledMethod isTestMethod and: [aCompiledMethod hasTestFailed])
		ifTrue: [
			failedExpressionTextInterval := aCompiledMethod failedExpressionInterval.
			styledSourceText 
				addAttribute: self createFailedExpressionAttribute
				from: failedExpressionTextInterval first
				to: failedExpressionTextInterval last ].
	^ styledSourceText.! !

Object subclass: #SFixedAnalyzer
	instanceVariableNames: 'package codeRevisionsCoverage installer filenames methodModificationsOverTime methodAdditionsOverTime fixedRelationshipOverTime fixedCoverageDeltas codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision
	^ self methodAdditionsOverTime at: revision! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision put: methodNames
	^ self methodAdditionsOverTime at: revision put: methodNames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/8/2010 21:04:06.838'!
analyzeCoverageForVersion: aVersionNumber	
	self codeSight addToManagedPackages: self package.
	self codeSight activateTracing.
	self runAllTestsOfPackage.
	self codeSight deactivateTracing.
	self gatherCoverageDataAndStoreAsVersion: aVersionNumber.
	self codeSight removeFromManagedPackages: self package.
	! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzeCoverageOverTime
	| alreadyRunThrough |
	alreadyRunThrough := 0.
	self filenames withIndexDo: [:filename :index |
		(index > alreadyRunThrough) ifTrue: [
			Transcript cr; show: index asString, ' started ... '.
			self installer uninstallPackage.
			Transcript show: 'uninstalled ...'.
			self installer installFromCache: filename.
			Transcript show: 'installed ...'.
			self analyzeCoverageForVersion: index.
			Transcript clear. ] ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 11:23:37.678'!
analyzeFixedRelationshipsOverTime
	|  madeItRunInRevisions revision methodsAdded methodsModified madeItRun fixedTests previousRevision previousCoveringTestMethods coverageDifference previousMadeItRun newTests newlyCoveringTests notNewButNewlyCoveringTests newAndNewlyCoveringTests |
	
	madeItRunInRevisions := fixedRelationshipOverTime := Dictionary new.
	filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		revision := self codeRevisionsCoverage at: index.
		methodsAdded := self addedMethodsAt: index.
		methodsModified := self modifiedMethodsAt: index.
	
		madeItRun := madeItRunInRevisions at: index put: Dictionary new.
	 
		revision keysAndValuesDo: [:appMethod :coveringTestMethods |
			fixedTests := madeItRun at: appMethod put: Set new.
			(methodsAdded includes: appMethod)
				ifTrue: [
					fixedTests addAll: coveringTestMethods.
					"entweder ist der test neu, falls nicht, muss ich aber von einem verschieben von funktionalitt ausgehen" ]
				ifFalse: [
					newTests := nil. "all tests that are in new this revision"
					previousRevision := self codeRevisionsCoverage at: (index - 1).
					previousCoveringTestMethods := previousRevision at: appMethod.
					coverageDifference := coveringTestMethods difference: previousCoveringTestMethods.
					
					previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
					fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods).
					
					newlyCoveringTests := coveringTestMethods difference: previousCoveringTestMethods.
					notNewButNewlyCoveringTests := newlyCoveringTests difference: newTests.
					"von diesen - notNewButNewlyCoveringTests; 
					 alle tests, die vor der erstellung dieser methode schon existiert haben,
					 da mglicherweise ein verschieben von funktionalitt statt gefunden hat"
					
					(methodsModified includes: appMethod)
						ifTrue: [ 
							newAndNewlyCoveringTests := newlyCoveringTests intersection: newTests.
							fixedTests addAll: newAndNewlyCoveringTests ]
						"ifFalse: [
							previousCoveringTestMethods isEmpty
								ifTrue: [
									fixedTests addAll: coverageDifference ]
								ifFalse: [
									previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
									fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods) ].
						 	]."
				 	].
			]. 
		Transcript clear ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:35'!
analyzeForMethodModifications
	| modifiedMethodNames previousRevision currentRevision patch modifications |
	previousRevision := nil.
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		currentRevision := self installer readVersionFromCache: filename.
		modifiedMethodNames := self modifiedMethodsAt: index put: Set new.
		previousRevision ifNotNil: [
			patch := previousRevision package snapshot patchRelativeToBase: currentRevision snapshot.
			modifications := patch operations select: [:ea | ea isModification and: [ea obsoletion isMethodDefinition]].
			modifications do: [:ea | 
				modifiedMethodNames add: (ea obsoletion className, ' >> #', ea obsoletion selector) ] ].
		previousRevision := currentRevision.
		Transcript clear. ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 13:02'!
analyzeForMethodsAdded
	| coverage previousCoverage addedMethodNames |
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		coverage := self codeRevisionsCoverage at: index.
		(index = 1) 
			ifTrue: [ self addedMethodsAt: index put: coverage keys ]
			ifFalse: [
				previousCoverage := self codeRevisionsCoverage at: (index - 1).
				addedMethodNames := coverage keys reject: [:ea | previousCoverage includesKey: ea].
				self addedMethodsAt: index put: addedMethodNames ].
		Transcript clear. ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:41'!
analyzeModificationsOverTime

	self 
		analyzeForMethodModifications;
		analyzeForMethodsAdded.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzePackage: aPackageInfo
	package := aPackageInfo..
	self 
		fetchVersionsToLocalCache;
		analyzeCoverageOverTime;
		analyzeModificationsOverTime;
		analyzeFixedRelationshipsOverTime.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:12'!
analyzePackage: aPackageInfo asVersion: aVersionNumber
	
	package := aPackageInfo.
	
	self 
		instrumentPackage;
		runAllTestsOfPackage;
		uninstrumentPackage;
		gatherCoverageDataAndStoreAsVersion: aVersionNumber
	! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:35'!
classesAndMetaclasses
	^ package classes gather: [ :aClass | {aClass. aClass class} ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:08'!
codeRevisionsCoverage
	^ codeRevisionsCoverage ifNil: [ codeRevisionsCoverage := Dictionary new. ]
	! !

!SFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:15.181'!
codeSight
	codeSight 
		ifNil: [
			codeSight := SCodeSight new.
			codeSight instrumentor: codeSight createWeavingInstrumentor ].
	^ codeSight! !

!SFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:57:50.644'!
codeSight: anObject
	codeSight := anObject! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:14'!
computeFixedCoverageDeltas
	| deltasInRev coveringTests |
	self codeRevisionsCoverage keysAndValuesDo: [:revisionIndex :coverageInRev |
		deltasInRev := self fixedCoverageDeltas at: revisionIndex put: Dictionary new.
		(self fixedRelationshipAt: revisionIndex) keysAndValuesDo: [:appMethod :fixedTests | 
			coveringTests := coverageInRev at: appMethod.
			coveringTests ifNotEmpty: [
				deltasInRev at: appMethod put: (fixedTests size / coveringTests size) ].
	 	].
	].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/9/2010 14:42:03.151'!
deltas
	^ deltas ifNil: [deltas := Dictionary new.]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
fetchVersionsToLocalCache
	
	self filenames: self installer fetchVersionsToLocalCache.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames
	^ filenames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames: aCollection
	filenames := aCollection! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:44'!
fixedCoverageDeltas
	^ fixedCoverageDeltas ifNil: [fixedCoverageDeltas := Dictionary new.]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:49'!
fixedCoverageDeltasAvg
	| deltasRevisionAvg |
	deltasRevisionAvg := Dictionary new.
	self fixedCoverageDeltas keysAndValuesDo: [:revisionIndex :deltasInRev |
		deltasRevisionAvg at: revisionIndex put: (deltasInRev values sum / deltasInRev values size) asFloat ].
	^ deltasRevisionAvg.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:54'!
fixedRelationshipAt: revisionIndex
	^ self fixedRelationshipOverTime at: revisionIndex! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:55'!
fixedRelationshipAt: revisionIndex put: methodToFixedTestsDict
	^ self fixedRelationshipOverTime at: revisionIndex put: methodToFixedTestsDict.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:53'!
fixedRelationshipOverTime
	^ fixedRelationshipOverTime ifNil: [ fixedRelationshipOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:11'!
gatherCoverageDataAndStoreAsVersion: aVersionNumber
	| codeCoverage |
	codeCoverage := self codeRevisionsCoverage at: aVersionNumber put: Dictionary new.
	self nonTestMethods do: [ :aCompiledMethod |
		codeCoverage 
			at: (aCompiledMethod qualifiedName)
			put: (aCompiledMethod coveringTestMethods collect: [:ea | ea qualifiedName]) ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:27.451'!
installer 
	^ installer ifNil: [ installer := SMczInstaller newForPackageNamed: self package packageName ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:47:14.323'!
instrumentPackage
	
	SWrappingInstrumentor systemInstrumentor instrumentPackage: package.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:12'!
methodAdditionsOverTime
	^ methodAdditionsOverTime ifNil: [ methodAdditionsOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:11'!
methodModificationsOverTime
	^ methodModificationsOverTime ifNil: [ methodModificationsOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision
	^ self methodModificationsOverTime at: revision! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision put: methodNames
	^ self methodModificationsOverTime at: revision put: methodNames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:59'!
nonTestMethods
	^ self classesAndMetaclasses gather: [ :aClass | 
		aClass methodDict values reject: [:aCompiledMethod | 
			aCompiledMethod selector isTestSelector ] ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package
	^ package! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package: aPackageInfo
	package := aPackageInfo! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:52.426'!
runAllTestsOfPackage	
	| aTestRunner aSuite |
	aTestRunner := STestRunner new.
	aSuite := TestSuite new.
	self testClasses do: [ :aTestClass | 
		aTestClass selectors 
			select: [:ea | ea isTestSelector ] 
			thenDo: [:ea | aSuite addTest: (aTestClass selector: ea) ]].
	aTestRunner runSuite: aSuite.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:21'!
testClasses
	^ package classes select: [ :aClass | aClass inheritsFrom: TestCase ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:47:14.317'!
uninstrumentPackage
	
	SWrappingInstrumentor systemInstrumentor uninstrumentPackage: package.! !

Object subclass: #SInfo
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'SightC-Browser'!

!SInfo class methodsFor: 'instance creation' stamp: 'bs 1/14/2010 12:45'!
do! !

!SInfo class methodsFor: 'system instance' stamp: 'bs 7/4/2010 12:49:00.417'!
instance
	"Instance := nil"
	^ Instance ifNil: [ Instance := SZeroInfo new ]! !

!SInfo class methodsFor: 'system instance' stamp: 'bs 1/14/2010 13:50'!
instance: anInfoObject
	Instance dependents do:  [ :ea | anInfoObject addDependent: ea ].
	Instance breakDependents.
	Instance := anInfoObject.
	Instance changed: #newTestResult.
	! !

!SInfo class methodsFor: 'system instance' stamp: 'bs 7/4/2010 12:49:00.424'!
resetToZeroInfo
	" self resetToZeroInfo "
	self instance: SZeroInfo new.! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isActive
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
isRunning
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
openTestRunner
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
testResult
	self subclassResponsibility! !

SInfo subclass: #SRealInfo
	instanceVariableNames: 'codeSight isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Browser'!

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
codeSight
	^ codeSight! !

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:37'!
codeSight: anObject
	codeSight := anObject.! !

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
csTestRunner
	^ self codeSight csTestRunner! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:50'!
isActive
	^ true! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:47'!
isClassManaged: aClass
	^ self codeSight isClassManaged: aClass! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:03'!
isRunning
	^ isRunning ifNil: [ isRunning := false ]! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self codeSight openTestRunner! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:42'!
testResult
	^ self csTestRunner result! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 12:56:32.951'!
update: aSymbol
	super update: aSymbol.
	(#(newTestResult startTestRun endTestRun) includes: aSymbol) ifFalse: [^ self].
	aSymbol = #startTestRun ifTrue: [isRunning := true].
	aSymbol = #endTestRun ifTrue: [isRunning := false].
	self changed: aSymbol.! !

SInfo subclass: #SZeroInfo
	instanceVariableNames: 'emptyTestResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Browser'!

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isActive
	^ false! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	^ false! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isRunning
	^ false! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self shouldNotImplement.! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:55'!
testResult
	^ emptyTestResult ifNil: [ emptyTestResult := TestResult new ] ! !

Object subclass: #SMczCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:28'!
addMczToCache: aStream at: aMczFileName
	"Need to write a clean zip."
	
	^ ZipArchive new
		readFrom: aStream;
		writeToFileNamed: (self cacheDirectory fullNameFor: aMczFileName).! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:35'!
cacheAt: aFileName

	^ ZipArchive new
		readFrom: (self cacheDirectory readOnlyFileNamed: aFileName)! !

!SMczCache class methodsFor: 'caching' stamp: 'mt 5/26/2009 18:48'!
cacheAt: aFileName ifNoneGetFrom: anHttpRepository
	"Return a zip archive for the mcz file."

	^ (self includes: aFileName)
		ifTrue: [self cacheAt: aFileName]
		ifFalse: [
			anHttpRepository
				readStreamForFileNamed: aFileName
				do: [:strm | self addMczToCache: strm at: aFileName]]! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 12:45'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 13:25'!
includes: aFileName

	^ self cacheDirectory includesKey: aFileName! !

Object subclass: #SMczInspectorOld
	instanceVariableNames: 'isRunning process reader currentMethodDefinition followAncestors currentAncestors classFilter selectorFilter lastDefinition currentStep maxSteps repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

SMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

SMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

!SMczInspectorOld class methodsFor: 'examples' stamp: 'bs 7/4/2010 12:48:25.966'!
exampleVersions
	| instance result repo |
	exampleCache ifNotNilDo: [ :c | ^ c ].
	result := OrderedCollection new.
	instance := self newForPackageNamed: 'Xpf-CodeTalk'.
	repo := instance repositories first key.
	(repo readableFileNames select: [ :filename | filename startsWith: 'Xpf-CodeTalk' ]) 
		do: 
			[ :filename | 
			instance zip: (SMczCache 
					cacheAt: filename
					ifNoneGetFrom: repo).
			instance loadVersionInfo.
			(instance zip memberNamed: 'snapshot.bin') ifNotNilDo: 
				[ :bin | 
				
				[ (DataStream on: bin contentStream) next definitions 
					select: 
						[ :def | 
						def isMethodDefinition and: [ def className = 'XpfCodeTalk' and: [ def selector = #todo ] ] ]
					thenDo: 
						[ :def | 
						result add: (CSRemoteMethodVersion 
								repository: repo
								info: instance info
								definition: def) ] ] 
					on: Error
					do: 
						[ :fallThrough | 
						"Unknown content in snapshot.bin!!"
						 ] ] ]
		displayingProgress: 'Preparing...'.
	exampleCache := result.
	^ result! !

!SMczInspectorOld methodsFor: 'adding repos' stamp: 'rkrk 9/19/2009 19:04'!
addRepository: anHttpRepository include: somePackageNames
	"Add the given repo and decide which packages
	to use when looking at the contents of the repo later."
	
	self repositories add: (anHttpRepository -> somePackageNames).! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
currentAncestors

	^ currentAncestors ifNil: [currentAncestors := Set new].! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 17:15'!
filenames
	| packageName aHttpRepository | 
	
	packageName := self repositories first value.
	aHttpRepository := self repositories first key.
	^ self
		filterFileNames: aHttpRepository readableFileNames
		packages: packageName.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'rkrk 9/19/2009 23:37'!
filterFileNames: someFileNames packages: somePackageNames

	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename |
		somePackageNames anySatisfy: [:name |
			self packageName: name matchesFileName: filename]].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ self followAncestors
		ifTrue: [result]
		ifFalse: [result reversed]! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:02'!
followAncestors

	^ followAncestors ifNil: [followAncestors := false].! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:13'!
followAncestors: anObject

	followAncestors := anObject.! !

!SMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 22:53'!
inspectDefinitions

	| definition updateObject |
	definition := self reader definitions
		detect: [:def | def isMethodDefinition
			and: [classFilter = def actualClass]
			and: [selectorFilter = def selector]]
		ifNone: [^ self].
	lastDefinition = definition ifTrue: [^ self].
	updateObject := Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> definition.
		#info -> self reader info}.
	self changed: #matchingVersionFound with: updateObject.
	lastDefinition := definition.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 18:06'!
inspectRepository: anHttpRepository include: somePackageNames

	| filenames shouldInspectDefs |
	filenames := self
		filterFileNames: anHttpRepository readableFileNames
		packages: somePackageNames.
	self maxSteps: filenames size.		
	filenames withIndexDo: [:filename :i |	
		self currentStep: i.
		self reader readFile: filename from: anHttpRepository.
		self inspectVersion.
		shouldInspectDefs := self followAncestors not
			or: [self currentAncestors isEmpty]
			or: [self currentAncestors anySatisfy: [:anc | anc name = self reader info name]].
		shouldInspectDefs ifTrue: [self inspectDefinitions].
		self followAncestors ifTrue: [self updateCurrentAncestry]].! !

!SMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 19:29'!
inspectSourceText: aText

	| result |
	result := aText attributesOfKind: XpfComplexAttribute.

	self changed: #resultFound with: (Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> currentMethodDefinition.
		#info -> self reader info.
		#attributes -> result}).! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 19:36'!
inspectVersion

	self changed: #versionFound with: self reader info.! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning

	isRunning ifNil: [self isRunning: false].
	^ isRunning! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning: anObject

	isRunning := anObject.
	self changed: #isRunning.! !

!SMczInspectorOld methodsFor: 'testing' stamp: 'rkrk 9/19/2009 23:40'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInspectorOld methodsFor: 'debugging' stamp: 'mt 5/26/2009 13:48'!
print

	Transcript show: ('Next Result: {1}>>{2} ({3}) - {4}' format: {
		currentMethodDefinition className.
		currentMethodDefinition selector.
		currentMethodDefinition category.
		self reader info name}); cr.! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:04'!
repositories

	^ repositories ifNil: [repositories := OrderedCollection new].! !

!SMczInspectorOld methodsFor: 'controlling' stamp: 'rkrk 9/19/2009 23:16'!
start

	process ifNotNil: [self stop].
	process := [
		[self isRunning: true.
		self repositories do: [:repo |
			self
				inspectRepository: repo key
				include: repo value.
			currentAncestors := nil].
		] ensure: [
			self
				isRunning: false;
				changed: #done]
	] fork priority: 20.! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersions

	self
		followAncestors: true;
		start.! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersionsFor: aSelector in: aClass

	classFilter := aClass.
	selectorFilter := aSelector.
	self startInspectVersions.! !

!SMczInspectorOld methodsFor: 'controlling' stamp: 'mt 5/9/2009 12:13'!
stop

	process ifNotNilDo: [:p | p terminate].
	process := nil.
	self isRunning: false.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:05'!
updateCurrentAncestry

	self reader info ancestors ifNotNilDo: [:newAnc |
		self currentAncestors addAll: newAnc].! !

Object subclass: #SMczInstaller
	instanceVariableNames: 'repository packageName currentStep maxSteps currentAncestors reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!SMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/26/2009 10:14'!
newForPackageNamed: aString

	| aPackage instance repos httpRepo |
	aPackage := MCPackage named: aString.
	aPackage hasWorkingCopy ifFalse: [^ nil].
	repos := aPackage workingCopy repositoryGroup repositories.
	httpRepo := repos detect: [:r | r isKindOf: MCHttpRepository ].
	
	instance := self new.
	instance 
		repository: httpRepo;
		packageName: aPackage name.
	^ instance ! !

!SMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/20/2009 17:29'!
newForPackagesNamed: packageName inRepo: mcRepository

	| instance |
	instance := self new.
	instance
		repository: mcRepository;
		packageName: packageName.
	^ instance! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:36'!
cacheAt: aFileName

	^ self cacheDirectory readOnlyFileNamed: aFileName! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:35'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
fetchVersionsToLocalCache
	| filenames |
	filenames := (self filterFileNames: self repository readableFileNames).	
	filenames do: [:filename |	
		self reader readFile: filename from: self repository ].
	^ filenames! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
filterFileNames: someFileNames
	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename | self packageMatchesFileName: filename].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ result reversed! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:53:45.547'!
installFromCache: aFileName
	MczInstaller installStream: (self cacheAt: aFileName).! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:29'!
packageMatchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: self packageName) ifFalse: [^ false].
	fileName size = self packageName size ifTrue: [true].
	followingChar := fileName at: self packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName

	^ packageName! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName: aName

	^ packageName := aName! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:28'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/23/2009 21:36'!
readVersionFromCache: aFileName
	^ MCMczReader versionFromStream: (self cacheAt: aFileName)! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:28.112'!
reader
	^ reader ifNil: [ reader := SMczReader new ]! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository

	^ repository! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository: aHttpRepo
	repository := aHttpRepo.! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/21/2009 20:52'!
uninstallPackage
	
	(PackageInfo named: self packageName) classes do: [:aClass | aClass removeFromSystem ]! !

Object subclass: #SMczReader
	instanceVariableNames: 'zip info definitions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!SMczReader commentStamp: 'mt 6/3/2009 11:04' prior: 0!
This is a simplified version of the McMczReader.!

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
associate: tokens

	| result |
	result := Dictionary new.
	tokens pairsDo: [:key :value | 
					value isString ifFalse: [value := value collect: [:ea | self associate: ea]].
					result at: key put: value].
	^ result! !

!SMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 16:59'!
definitions

	"if it does not work, look at loadDefinitions"
	^ definitions ifNil: [
		(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
			[definitions := (DataStream on: bin contentStream) next definitions]
				on: Error
				do: [:fallThrough | definitions := OrderedCollection new]]].! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
extractInfoFrom: dict

	^ MCVersionInfo
		name: (dict at: #name ifAbsent: [''])
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message ifAbsent: [''])
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author ifAbsent: [''])
		ancestors: ((dict at: #ancestors ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])
		stepChildren: ((dict at: #stepChildren ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])! !

!SMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:58'!
getDefinitionByClass: aClass selector: aSelector

	^ self definitions
		detect: [:def |
			def actualClass = aClass
				and: [def selector = aSelector]]
		ifNone: []! !

!SMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:00'!
info

	^ info ifNil: [info := self extractInfoFrom: (self parseMember: 'version')]! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info: anObject

	info := anObject.! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:17'!
loadDefinitions

	(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
		[self	definitions:
			(DataStream on: bin contentStream) next definitions]
		on: Error
		do: [:fallThrough |
			self definitions: OrderedCollection new.
			Transcript show: 'Unknown content in snapshot.bin!!'; cr]].! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
loadVersionInfo

	info := self extractInfoFrom: (self parseMember: 'version')! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:12'!
parseMember: fileName

	| tokens |
	tokens := (MCScanner scanTokens: (zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!SMczReader methodsFor: 'public' stamp: 'bs 7/4/2010 12:48:25.981'!
readFile: aFilename from: aRepository 
	self
		repository: aRepository;
		zip: (SMczCache 
				cacheAt: aFilename
				ifNoneGetFrom: aRepository)! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository

	^ repository! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository: anObject

	repository := anObject.! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip

	^ zip! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip: anObject

	zip := anObject.! !

Object subclass: #SPackageChooser
	instanceVariableNames: 'list listSelections codeSight window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-TestTracer'!

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
build
	^ ToolBuilder build: self new! !

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
initialize
	"CSTraceChooser initialize"
	self registerInToolsFlap! !

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
open
	^ self new open! !

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTraceChooser build 'Test Traces' 'Choose your packages for test tracing.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!SPackageChooser methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:39'!
buildWith: builder
	| windowSpec listSpec buttonSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec 
		model: self;
		label: 'Package Chooser';
		children: OrderedCollection new;
		closeAction: #close.
		
	listSpec := builder pluggableMultiSelectionListSpec new.
	listSpec 
		model: self;
		list: #list;
		getSelectionList: #listSelectionAt:;
		setSelectionList: #listSelectionAt:put:;
		frame: (0@0corner: 1@0.8).
	windowSpec children add: listSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec
		model: self;
		label: 'Refresh';
		action: #refresh;
		frame: (0@0.8 corner: 1@1).
	windowSpec children add: buttonSpec.
	
	^builder build: windowSpec! !

!SPackageChooser methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:13'!
close
	window := nil! !

!SPackageChooser methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:34'!
codeSight
	^ codeSight! !

!SPackageChooser methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:34'!
codeSight: anObject
	codeSight := anObject! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
list
	^ list ifNil: [ list := self packageNamesSorted ]! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelectionAt: index
	^ self listSelections at: index! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelectionAt: index put: isMarked
	| selectedPackage newValue successfullyRegistered | 
	selectedPackage := self packageAt: index.
	newValue := isMarked.
	isMarked 
		ifTrue: [
			successfullyRegistered := self registerPackage: selectedPackage.
			successfullyRegistered 
				ifFalse: [ newValue := isMarked not ] ]
		ifFalse: [ self unregisterPackage: selectedPackage ].
	self changed: #list.
	^ self listSelections at: index put: newValue.! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelections
	listSelections ifNil: [
		self list ifNotNil: [
			listSelections := Array new: self list size withAll: false.
			self list doWithIndex: [ :each :index |
				(self registeredPackages includes: each) ifTrue: [
					listSelections at: index put: true ]]]].
	^ listSelections! !

!SPackageChooser methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:13'!
open
	window
		ifNil: [ window := ToolBuilder open: self ]
		ifNotNil: [ 
			window comeToFront.
			window isCollapsed ifTrue: [ window expand ] ].
	^ window.! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageAt: index
	| packageName |
	packageName := self list at: index.
	^ self packageNamed: packageName! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageNamed: aName
	^ PackageOrganizer default packageNamed: aName ifAbsent: [].! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageNamesSorted
	| packageNames criticalPackages |
	packageNames := PackageOrganizer default packages 
			collect: [ :packageInfo | packageInfo packageName ].
	
	criticalPackages := {'Collections'. 'CollectionsTests'.
								'Kernel'. 'KernelTests'.
								'Graphics'. 'GraphicsTests'.
								'ST80'. 'SUnit'. 'System' }.
	^ (packageNames reject: [:package | 
			criticalPackages anySatisfy: [:critical | 
				critical = package] ]) sort! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
refresh
	list := nil.
	listSelections := nil.! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 09:59:53.122'!
registerPackage: aPackage
	^ self codeSight addToManagedPackages: aPackage! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 10:00:39.835'!
registeredPackages
	^ self codeSight managedPackages! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 10:00:25.812'!
unregisterPackage: aPackage
	^ self codeSight removeFromManagedPackages: aPackage! !

Object subclass: #SPartialTracingBenchmarker
	instanceVariableNames: 'packageToBenchmark codeSight coveredMethodTestTimes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Analyzing'!

!SPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:48:15.202'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := SCodeSight new.
	codeSight instrumentor: SWeavingInstrumentor new.
	codeSight instrumentor codeSight: codeSight.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!SPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 1/24/2010 15:02'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:15.188'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := SCodeSight new.
	codeSight instrumentor: codeSight createWeavingInstrumentor.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/24/2010 14:39'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:25.298'!
benchmarkPartialTracingTimes
	| result testTime activationInstr |
	self halt.
	self codeSight instrumentor instrumentPackage: self packageToBenchmark.
	result := IdentityDictionary new.
	testTime := nil.
	self coveredMethods withIndexDo: [ :m :index |
		Transcript show: index asString; cr.
		Transcript show: 'covering: ',  m coveringTestMethods size asString; cr.
		testTime :=
			(self codeSight instrumentor canInstrument: m selector inClass: m methodClass)
				ifFalse: [ (m coveringTestMethods collect: [ :tm | self coveredMethodTestTimes at: m ]) sum ]
				ifTrue: [
					[ activationInstr := SInstrumentedMethod activationOn: m selector inClass: m methodClass.
					activationInstr install.
					self halt.
					codeSight csTestRunner reset; runTestMethods: m coveringTestMethods.
					activationInstr uninstall. ] timeToRunWithoutGC ].
		result at: m put: testTime. ].
	codeSight instrumentor uninstrumentPackage: self packageToBenchmark.
	^ result.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:02.492'!
classesAndMetaclasses
	^ self packageToBenchmark classes flatCollect: [ :c | {c. c class} ]! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight
	^ codeSight! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight: anObject
	codeSight := anObject! !

!SPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 1/24/2010 15:45'!
collectAllTestMethods
	^ (self packageToBenchmark classes
		select: [ :c | c isTestCaseClass ])
			flatCollect: [ :c | c testMethods ] ! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.559'!
coveredMethodTestTimes
	^ coveredMethodTestTimes! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.56'!
coveredMethodTestTimes: anObject
	coveredMethodTestTimes := anObject! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:54.897'!
coveredMethods
	^ self nonTestMethods select: [ :m | m hasCoveringTestMethods ].! !

!SPartialTracingBenchmarker methodsFor: 'initialize-release' stamp: 'bs 7/4/2010 12:48:15.195'!
initialize
	super initialize.
	self codeSight: SCodeSight new.
	self codeSight instrumentor: self codeSight createWeavingInstrumentor.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:23.258'!
nonTestMethods
	^ (self classesAndMetaclasses flatCollect: [ :c | c methodDict values ]) select: [ :m | m isTestMethod not ].! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:05'!
packageToBenchmark
	^ packageToBenchmark! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:01'!
packageToBenchmark: anObject
	packageToBenchmark := anObject! !

!SPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 1/24/2010 16:12'!
runAndTraceAllTests
	self codeSight activateTracing.
	self codeSight csTestRunner runTestMethods: self collectAllTestMethods.
	self codeSight deactivateTracing.! !

Object subclass: #SReplicateMessage
	instanceVariableNames: 'command headerBytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Distribution'!

!SReplicateMessage class methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:47:20.627'!
receiveFrom: aSocket
	^ self new 
		receiveFrom: aSocket;
		yourself! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/8/2010 20:15:20.805'!
applyCommand
	Compiler evaluate: self commandAsString.! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command
	^ command! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command: anObject
	command := anObject! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 13:08:26.15'!
commandAsString
	^ self command! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:30.074'!
headerBytes
	^ headerBytes ifNil: [headerBytes := ByteArray new: self numberOfHeaderBytes]! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:20.283'!
numberOfHeaderBytes
	^ 4.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:37:46.473'!
receiveFrom: aSocket
	| bytesToRead bytesOfCommandString |
	bytesToRead := self receiveMessageLengthHeader: aSocket.
	bytesOfCommandString := ByteArray new: bytesToRead.
	aSocket receiveDataInto: bytesOfCommandString.
	self command: bytesOfCommandString asString.
	Transcript show: 'received command: ', self commandAsString; cr.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:36:12.351'!
receiveMessageLengthHeader: aSocket

	aSocket receiveDataInto: self headerBytes.
	^ self headerBytes unsignedLongAt: 1 bigEndian: true.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:59:14.146'!
sendOn: aSocket
	| commandString |
	commandString := self commandAsString.
	self headerBytes unsignedLongAt: 1 put: (commandString byteSize) bigEndian: true.
	aSocket sendData: self headerBytes, commandString asByteArray! !

Object subclass: #SStepper
	instanceVariableNames: 'blockToExecute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-TestTracer'!

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
executeInNextStep: aBlock
	blockToExecute := aBlock.
	ActiveWorld startStepping: self at: Time millisecondClockValue selector: #step arguments: nil stepTime: nil.! !

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:02'!
shouldGetStepsFrom: aWorld
	^ActiveWorld == aWorld! !

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
step
	blockToExecute value.
	ActiveWorld stopStepping: self selector: #step.! !

Object subclass: #SSystemEventMock
	instanceVariableNames: 'item kind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-Tests'!

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
item
	^ item! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
item: anObject
	item := anObject! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:57'!
kind
	^ kind! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:57'!
kind: anObject
	kind := anObject! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
oldItem
	^ item! !

Object subclass: #STestStatistic
	instanceVariableNames: 'receiverClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-TestTracer'!

!STestStatistic methodsFor: 'initialize-release' stamp: 'bs 10/28/2009 15:19'!
addCallInDepth: aNumber
	self flag: #rkrk. "for benchmarking"! !

!STestStatistic methodsFor: 'public' stamp: 'replica 2/24/2010 20:47:09.92'!
addReceiverClass: aClass
	self receiverClasses add: aClass.! !

!STestStatistic methodsFor: 'public' stamp: 'replica 2/24/2010 20:47:22.937'!
addReceiverClasses: classes
	self receiverClasses addAll: classes.! !

!STestStatistic methodsFor: 'as yet unclassified' stamp: 'bs 10/28/2009 15:18'!
printOn: stream

	stream
		nextPutAll: 'CSTestStatistic<Trace:';
		nextPutAll: 'Receivers:';
		print: self receiverClasses;
		nextPut: $>.! !

!STestStatistic methodsFor: 'accessing' stamp: 'bs 1/16/2010 22:30'!
receiverClasses
	^ receiverClasses 
		ifNil: [receiverClasses := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

!Debugger methodsFor: '*SightC' stamp: 'bs 7/4/2010 12:48:42.24'!
debug: label executeBefore: aBlock
	"Open a full DebuggerView."
	Smalltalk isMorphic
		ifTrue:
			[self openFullMorphicLabel: label.
			 SStepper new executeInNextStep: [aBlock value: self].
			 errorWasInUIProcess := Project spawnNewProcessIfThisIsUI: interruptedProcess.
			 ^self].
! !

!Debugger methodsFor: '*SightC' stamp: 'bs 4/16/2009 11:16'!
restartAfterMethodChanged 
	"The retrieved information has changed and its source must now be  
	updated. In this case, the retrieved information is the method of the  
	selected context."
	| selector classOfMethod category h ctxt |
	
	h := self selectedContext finalBlockHome.
	self resetContext: h.
	classOfMethod := self selectedClass.
	category := self selectedMessageCategoryName.
	selector := self selectedMessageName.
	
	contents := classOfMethod sourceCodeAt: selector.
	ctxt := interruptedProcess popTo: self selectedContext.
	interruptedProcess suspendedContext privRefreshWith: (classOfMethod compiledMethodAt: selector).
	"interruptedProcess
		restartTopWith: (classOfMethod compiledMethodAt: selector)."
	contextVariablesInspector object: nil.
	theMethodNode := Preferences browseWithPrettyPrint
		ifTrue: [ctxt methodNodeFormattedAndDecorated: Preferences colorWhenPrettyPrinting]
		ifFalse: [ctxt methodNode].
	sourceMap := theMethodNode sourceMap.
	tempNames := theMethodNode tempNames.
		
	self resetContext: ctxt.
	self changed.
	^ true! !

MwMethodWrapper subclass: #SRefactoringVariationWrapper
	instanceVariableNames: 'variationMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightC-TestTracer'!

!SRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 22:59'!
initialize
	"self initialize"
	super initialize! !

!SRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 22:14:46.852'!
on: aSelectorSymbol inClass: aClass withCode: sourceCodeString
	| wrapper variationAst |
	wrapper := super on: aSelectorSymbol inClass: aClass.
	variationAst := Compiler new 
						compile: sourceCodeString in: aClass
						notifying: nil
						ifFail: [].
	wrapper variationMethod: (variationAst generateUsing: aClass).
	^ wrapper! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 23:00'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	^ self variationMethod valueWithReceiver: anObject arguments: anArrayOfObjects.! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 10:02:28.155'!
variationMethod
	^ variationMethod! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 10:02:18.259'!
variationMethod: aCompiledMethod
	variationMethod := aCompiledMethod! !

TestRunner subclass: #STestRunner
	instanceVariableNames: 'isInTddAutoRunMode runsTestsInBackground modifiedMethods tddMonitor codeSight window'
	classVariableNames: 'RunInBackgroundMonitor'
	poolDictionaries: ''
	category: 'SightC-TestTracer'!

STestRunner class
	instanceVariableNames: 'classesToBeTraced'!

STestRunner class
	instanceVariableNames: 'classesToBeTraced'!

!STestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 15:28'!
initialize
	"CSTestRunner initialize"
	self registerInWorldMenu; registerInToolsFlap.! !

!STestRunner class methodsFor: 'synchronizing' stamp: 'bs 7/4/2010 12:48:52.366'!
measureExecutionTimesForPackagesWith: aString
	"CSTestRunner measureExecutionTimes"
	|packages classes testCase time testClasses testCaseTimes result coveredMethods coveringTestMethods coveredMethodsTestTimeDeltas classTestTime aTestRunner aSuite |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: aString].
	packages do: [:p | self instrumentor instrumentPackage: p].
	classes := (packages gather: [:p | p classes]) asSet.

	aTestRunner := STestRunner new.
	testCase := nil.
	time := nil.

	testClasses := classes select: [:class | class inheritsFrom: TestCase].
	testCaseTimes := Dictionary new.
	testClasses do: [:testClass | 
		testClass selectors select: [:s | s isTestSelector] thenDo: [:s | 
			aSuite := TestSuite new.
			aSuite addTest: (testClass selector: s).
			time := [aTestRunner runSuite: aSuite] timeToRun.
			testCaseTimes at: (testClass >> s) put: time]].

	result := Dictionary new.	
	coveredMethods := nil.
	coveredMethodsTestTimeDeltas := nil.
	classes select: [:c | c methodDict values contains: [:m | m hasCoveringTestMethods]]
	 		  thenDo: [:aClass |
		coveredMethods := aClass methodDict values select: [:m | m hasCoveringTestMethods ].
		coveringTestMethods := (coveredMethods gather: [:m | m coveringTestMethods]) asSet.
		classTestTime := (coveringTestMethods collect: [:m | testCaseTimes at: m ifAbsent: [0]]) sum.
		
		coveredMethodsTestTimeDeltas := classTestTime - (coveredMethods collect: [:cm | 
			(cm coveringTestMethods collect: [:tm | testCaseTimes at: tm ifAbsent: [0]]) sum]).
		
		coveredMethodsTestTimeDeltas ifNotEmpty: [
			result at: aClass put: {coveredMethods size. coveredMethodsTestTimeDeltas max. coveredMethodsTestTimeDeltas average}]].
	
	packages do: [:p | self instrumentor uninstrumentPackage: p].
	^ result
! !

!STestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:52.385'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( #STestRunner build 'CodeSight Test Runner' 'A production scale test-runner for XP Forums.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!STestRunner class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 20:33'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'CodeSight Test Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!STestRunner class methodsFor: 'synchronizing' stamp: 'test 9/17/2009 23:32'!
resetSourceCodeAccessMonitor
	^ RunInBackgroundMonitor := nil! !

!STestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/14/2009 10:50'!
sourceCodeAccessMonitor
	^ RunInBackgroundMonitor ifNil: [ RunInBackgroundMonitor := Monitor new ]! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:02'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		layout: #vertical;
		children: {
			self buildButtonsWith: aBuilder.
			self buildTddControlButtonsWith: aBuilder
			};
		yourself.! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:18'!
buildTddControlButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: (self tddFlags collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:16'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.84 );
				yourself);				
			add: ((self buildClassesWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.84 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.84);
				yourself);
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.84 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	^ aBuilder build: window.! !

!STestRunner methodsFor: 'initialize-release' stamp: 'replica 5/10/2010 17:51:44.951'!
cleanUp

	self
		disableRunningTestsInBackground;
		tddAutoRunStop;
		reset.! !

!STestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:15'!
close
	window := nil! !

!STestRunner methodsFor: 'accessing' stamp: 'bs 1/4/2010 13:31'!
codeSight
	^ codeSight! !

!STestRunner methodsFor: 'accessing' stamp: 'bs 1/4/2010 13:31'!
codeSight: anObject
	codeSight := anObject! !

!STestRunner methodsFor: 'running' stamp: 'bs 4/30/2009 12:09'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self debugTest: each ].! !

!STestRunner methodsFor: 'running' stamp: 'bs 1/4/2010 16:07'!
debugTest: aTestCase
	| outerTest | 
	outerTest := self codeSight runningTestMethod.
	self codeSight testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	aTestCase debug.
	self codeSight testMethodGoingToRun: outerTest.! !

!STestRunner methodsFor: 'running' stamp: 'bs 1/1/2010 22:40'!
defectTestMethods
	^ self result defectTestMethods! !

!STestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
disableRunningTestsInBackground
	^ runsTestsInBackground := false! !

!STestRunner methodsFor: 'private' stamp: 'bs 1/5/2010 15:30'!
disableTddAutoRunMode
	self isInTddAutoRunMode: false.! !

!STestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
enableRunningTestsInBackground
	^ runsTestsInBackground := true! !

!STestRunner methodsFor: 'private' stamp: 'bs 1/5/2010 15:30'!
enableTddAutoRunMode
	self isInTddAutoRunMode: true.! !

!STestRunner methodsFor: 'event handling' stamp: 'bs 1/17/2010 21:55'!
handle: aCsEvent
	self isInTddAutoRunMode 
		ifTrue: [ aCsEvent processOn: self ]! !

!STestRunner methodsFor: 'accessing' stamp: 'bs 1/4/2010 15:16'!
instrumentor
	^ self codeSight instrumentor! !

!STestRunner methodsFor: 'auto run mode' stamp: 'bs 9/11/2009 14:52'!
isInTddAutoRunMode
	^ isInTddAutoRunMode ifNil: [isInTddAutoRunMode := false].! !

!STestRunner methodsFor: 'private' stamp: 'bs 1/3/2010 15:46'!
isInTddAutoRunMode: aBoolean
	isInTddAutoRunMode := aBoolean.
	self changed: #tddAutoRunModeLabel! !

!STestRunner methodsFor: 'ui-building' stamp: 'mab 4/2/2009 20:33'!
label
	^ 'CodeSight Test Runner'! !

!STestRunner methodsFor: 'event handling' stamp: 'bs 1/15/2010 11:35'!
nonTestMethodRemoved: aTestMethod
	self tddMonitor nonTestMethodRemoved: aTestMethod.! !

!STestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:14'!
open
	window
		ifNil: [ window := ToolBuilder open: self ]
		ifNotNil: [ 
			window comeToFront.
			window isCollapsed ifTrue: [ window expand ] ].
	^ window.! !

!STestRunner methodsFor: 'accessing' stamp: 'bs 9/10/2009 13:58'!
resetTestCasesToRun
	^ testCasesToRun := nil.! !

!STestRunner methodsFor: 'running' stamp: 'bs 1/1/2010 22:40'!
runFailedTests
	self runTestMethods: self defectTestMethods.! !

!STestRunner methodsFor: 'running' stamp: 'bs 7/4/2010 12:48:52.358'!
runSuite: aSuite 
	| runSuiteSynchronized |
	runSuiteSynchronized := [	
		STestRunner sourceCodeAccessMonitor critical: [
			self changed: #startTestRun.
			super runSuite: aSuite.
			self updateResultsInHistory.
			self changed: #endTestRun]].

	(self runsTestsInBackground and: [
			ProcessBrowser isUIProcess: Processor activeProcess])
		ifTrue: [ runSuiteSynchronized forkAt: Processor userBackgroundPriority ]
		ifFalse: [ runSuiteSynchronized value ]! !

!STestRunner methodsFor: 'running' stamp: 'bs 2/25/2010 10:33:20.757'!
runTest: aTestCase
	| outerTest | 
	outerTest := self codeSight runningTestMethod.
	self codeSight testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	super runTest: aTestCase.
	self codeSight testMethodGoingToRun: outerTest.
	
	self changed: #newTestResult with: result.! !

!STestRunner methodsFor: 'running' stamp: 'bs 1/25/2010 16:59:54.329'!
runTestMethods: testMethods
	| aSuite |
	
	testMethods ifNotEmpty: [
		aSuite := TestSuite new.
		aSuite addTests: (testMethods collect: [:ea | ea newTestCase]).
		self runSuite: aSuite ].! !

!STestRunner methodsFor: 'running' stamp: 'bs 12/3/2009 22:32'!
runTestsInSuite: testMethods
	| aSuite |
	
	testMethods ifNotEmpty: [
		aSuite := TestSuite new.
		aSuite addTests: (testMethods collect: [:ea | ea newTestCase]).
		self reset; runSuite: aSuite ].! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:11'!
runningTestsInBackgroundLabel
	^ self runsTestsInBackground
		ifTrue: [ 'DisableRunningTestsInBackground' ]
		ifFalse: [ 'EnableRunningTestsInBackground' ]! !

!STestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:17'!
runsTestsInBackground
	^ runsTestsInBackground ifNil: [runsTestsInBackground := false]! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 13:06'!
tddAutoRunModeLabel
	^ self isInTddAutoRunMode 
		ifTrue: [ 'Stop Tdd Auto Run Mode' ]
		ifFalse: [ 'Start Tdd Auto Run Mode' ]! !

!STestRunner methodsFor: 'auto run mode' stamp: 'bs 1/14/2010 13:57'!
tddAutoRunStart
	(self isInTddAutoRunMode)
		ifFalse: [
			self enableTddAutoRunMode ]! !

!STestRunner methodsFor: 'auto run mode' stamp: 'bs 1/14/2010 13:57'!
tddAutoRunStop
	(self isInTddAutoRunMode)
		ifTrue: [
			self disableTddAutoRunMode ]! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:03'!
tddFlags
	^ #(( #tddAutoRunModeLabel #toggleTddAutoRunMode )
		( #runningTestsInBackgroundLabel #toggleRunningTestsInBackground )).! !

!STestRunner methodsFor: 'event handling' stamp: 'bs 7/4/2010 12:48:44.912'!
tddMonitor
	^ tddMonitor ifNil: [tddMonitor := STddMonitor new]! !

!STestRunner methodsFor: 'event handling' stamp: 'bs 12/22/2009 18:36'!
tddMonitor: aTddMonitor
	tddMonitor := aTddMonitor! !

!STestRunner methodsFor: 'event handling' stamp: 'bs 1/15/2010 11:27'!
testMethodRemoved: aTestMethod
	self result removeIfPresent: aTestMethod.
	self tddMonitor testMethodRemoved: aTestMethod.! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:21'!
toggleRunningTestsInBackground
	self runsTestsInBackground
		ifTrue: [ self disableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]
		ifFalse: [ self enableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]! !

!STestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 13:07'!
toggleTddAutoRunMode
	self isInTddAutoRunMode 
		ifTrue: [ self tddAutoRunStop. self changed: #tddAutoRunModeLabel. ]
		ifFalse: [ self tddAutoRunStart. self changed: #tddAutoRunModeLabel. ]! !

!STestRunner methodsFor: 'running' stamp: 'bs 3/3/2010 09:01:30.036'!
updateResultsInHistory
	(TestResult includesSelector: #updateResultsInHistory) 
		ifTrue: [ self result updateResultsInHistory ].! !
SReplicator initialize!
SFailedExpressionStyler initialize!
SPackageChooser initialize!
SRefactoringVariationWrapper initialize!
STestRunner initialize!
